

PROGRAM CHKPOP3;            {Check POP3 for mail}

{$A+,B-,D+,E+,F-,G+,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V+,X+}
{$M 16384,0,655360}


Uses DOS,ABI,CRT,XSTRING,ABI_DOM;

{$I TCP.INC}

CONST VerifyArticle: Boolean = FALSE;

TYPE
    MsgREC = RECORD                  { status msgs are related to NNTP }
              Pro:Char;     { Progress  1 = Information Message
                                           2 = Command OK
                                           3 = Command OK So far, send rest
                                           4 = Command correct, but undoable
                                           5 = Command unimplemented/incorrect
                                               or program error occurred}
              Cat:Char;     { Catagory  0 = Connection/Setup/Misc
                                           1 = Newsgroup Selection
                                           2 = Article Selection
                                           3 = Distribution Functions
                                           4 = Posting
                                           8 = Nonstandard (private extensions)
                                           9 = Debugging output}
              Ext:Char;     { used for multiple message types of above }
              Res:Word;
            end;

var Msg : MsgREC;
		CurSession			: TcpSessionREC;
    ArtEstimate:LongInt;
    ArtFirst:LongInt;
    ArtLast :LongInt;
    ArtGroup:String;
    ArtLines:LongInt; {Lines: }
    ArtLine:LongInt;  {current}
    ArtNum:LongInt;
    Result: Integer;
    TmpAddr: IPAddr;
    TmpPort: Word;
    TmpLong: LongInt;
    TmpStr:String;
    TmpDis:String;
    StatusBarLU:LongInt;     {StatusBar last update}
    Spinner:Word;
    I : Integer;
    A : String;
    B : String;
    CfgPOP3:String;
    CfgUSER:String;
    CfgPASS:String;


Procedure ShowStatus(C:tcpSessionREC);
 begin
     Write(ByteToHexASCII(C.Handle)+' ');
     Write('FROM:'+IPTOASCII(TcpDrvInfo.myip)+':');
     if C.Tcp_srce=0 then Write('[',C.LocalPort,']')
                               else Write(C.Tcp_srce);
     Write('      =>  TO:  '+IPTOASCII(C.IPDest)+':');
     Writeln(C.Tcp_dest,'       ',tcpState[C.Status.State]);

     Writeln('State         : ',C.Status.State);
     Write('BytesReady    : ',C.Status.BytesReady);
     Writeln('    BytesGoing    : ',C.Status.BytesGoing);
     Write('Source IP     : ',IPTOASCII(C.Status.ip_srce));
     Writeln('    Destination IP: ',IPTOASCII(C.Status.ip_dest));
     Writeln(' IP Prot      : ',C.Status.ip_prot);
     Writeln('  A C T I V E?: ',C.Status.Active);
     Writeln;
 end;

Function BWStr(var TmpNum:word; Len:Byte):String;
 var
  TmpStr:String;
 begin
    case Len of
      0: Str(TmpNum,TmpStr);
      1: Str(TmpNum:1,TmpStr);
      2: Str(TmpNum:2,TmpStr);
      3: Str(TmpNum:3,TmpStr);
      4: Str(TmpNum:4,TmpStr);
      5: Str(TmpNum:5,TmpStr);
      6: Str(TmpNum:6,TmpStr);
      7: Str(TmpNum:7,TmpStr);
     else
        Str(TmpNum,TmpStr);
    end;
  BWStr:=TmpStr;
 end;

Function BLStr(var TmpNum:LongInt; Len:Byte):String;
 var
  TmpStr:String;
 begin
    case Len of
      0: Str(TmpNum,TmpStr);
      1: Str(TmpNum:1,TmpStr);
      2: Str(TmpNum:2,TmpStr);
      3: Str(TmpNum:3,TmpStr);
      4: Str(TmpNum:4,TmpStr);
      5: Str(TmpNum:5,TmpStr);
      6: Str(TmpNum:6,TmpStr);
      7: Str(TmpNum:7,TmpStr);
     else
        Str(TmpNum,TmpStr);
    end;
  BLStr:=TmpStr;
 end;

Procedure ShowStatusBar(Other:String);
 var
	 ToShow:String;
	 LastX:Byte;
	 LastY:Byte;
	 TmpX:Byte;
	 TmpY:Byte;
	 LWX:Byte;
	 LWY:Byte;
	 LWXX:Byte;
	 LWYY:Byte;
   ha, ma, sa, sa100 : Word;
 begin
   GetTime(ha, ma, sa, sa100);
   If StatusBarLU=Trunc(sa100/10) then exit;
   StatusBarLU:=Trunc(sa100/10);
   TmpX:=WHEREX; TmpY:=WHEREY;
	 Window(1, 1, 80, 1);
   If Spinner> 3 then Spinner:=0;
	 Inc(Spinner);
	 GotoXY(1,1);
	 TextColor(9);
   If Spinner=1 then Write('/\');
   If Spinner=2 then Write('--');
   If Spinner=3 then Write('\/');
   If Spinner=4 then Write('||');

   Write(' Time= ',ha:2,':',ma:2,':',sa:2,'.',sa100:2,'  ');
   If Other<>'' then Write(Other);
   ClrEol;
	 NormVideo;
   Window(1, 2, 80, 25);
   GotoXY(TmpX, TmpY);
 end;



  (* Number of substrings in a string *)
  function PARSENFN (sj : string) : integer;
  var i, n, p : integer;
  begin
    p := Length(sj);
    n := 0;
    i := 1;
    repeat
      while (sj[i] <= #32) and (i <= p) do Inc(i);
      if i > p then begin parsenfn := n; exit; end;
      while (sj[i] > #32) and (i <= p) do Inc(i);
      Inc(n);
      if i > p then begin parsenfn := n; exit; end;
    until false;
  end;  (* parsenfn *)
  {}
  (* Get substrings from a string *)
  function PARSERFN (sj : string; PartNumber : integer) : string;
  var i, j, n, p : integer;
      stash      : string;
  begin
    if (PartNumber < 1) or (PartNumber > PARSENFN(sj)) then
      begin PARSERFN := ''; exit; end;
    p := Length(sj);
    n := 0;
    i := 1;
    repeat
      while (sj[i] <= #32) and (i <= p) do Inc(i);
      Inc(n);
      if n = PartNumber then
        begin
          j := 0;
          while (sj[i] > #32) and (i <= p) do
            begin
              Inc(j);
              stash[0] := chr(j);
              stash[j] := sj[i];
              Inc(i);
            end;
          PARSERFN := stash;
          exit;
        end
       else
         while (sj[i] > #32) and (i <= p) do Inc(i);
    until false;
  end;  (* parserfn *)


Function MainCHKPOP(cfgfilename:string; host:IPAddr; hoststring:string):Integer;
 var
   CfgFile:text;
   TmpStr:String;
   Result:Integer;
   TmpBoolean:Boolean;
 begin
   MainCHKPOP:=-1;
   TmpPort:=POP3_PORT;
  TmpDis:=IPTOASCII(TcpDrvInfo.myip)+':'+
          BWStr(CurSession.LocalPort,0)+' => '+IPTOASCII(host)+':'+BWStr(TmpPort,0)+' ';

  ShowStatusBar(TmpDis+' attempting connection');
  Result:=Tcp_Open(CurSession,0,host,0,TmpPort,450);
  if Result=no_error then Writeln('Connection Established');

  ShowStatusBar(ByteToHEXASCII(CurSession.Handle)+TmpDis+tcpState[CurSession.Status.State]);

  if Result=err_timeout then
    begin
      Writeln('No Response from '+IPTOASCII(CurSession.IPDest));
      MainCHKPOP:=-5;
      exit;
    end;

  Result:=tcp_get(CurSession, 2, 750);
  If Result=err_timeout then
    begin
      Writeln('No Response from POP3 Server after connecting');
      MainCHKPOP:=-2;
      exit;
    end;
  If Result<>0 then
    begin
      Writeln('Error on POP3 negotiation (first receive)');
      MainCHKPOP:=-1;
      exit;
    end;

  Result:=Tcp_Status(CurSession,0);
  ShowStatus(CurSession);
  Write(#34);
  TmpStr:=ShowBuffer(CurSession.Buffer, 1);
  Writeln(#34);

  If APOPLogin(CfgUSER, CfgPASS, TmpStr) then
    begin
      Writeln('*!* Login successful! ');
    end;

        {*CONSTRUCTION_POINT*}
 end;



BEGIN
 FillChar (CurSession, SizeOf(CurSession), 0);
 Writeln;
 Writeln('Turbo Pascal 7.0 - CHKPOP3 for DOS');
 Writeln;

 TmpAddr:=NullAddr;

 if ParamCount<3 then
    begin
     Writeln('CHKPOP3 <filename>');
     Writeln;
     Writeln('        File is ASCII containing (by line): <pop3server>');
     Writeln('                                            <username>  ');
     Writeln('                                            <password>  ');
     Halt(3);
    end;

 A:=ParamStr(3);
 B:=ParamStr(2);
 aton(A,TmpAddr);
 TmpLong:=0;
 Move(TmpAddr,TmpLong,4);
 If TmpLong=0 then
   begin
    Writeln('Resolving ',A);
    Result:=resolve(A, TmpAddr, 0);
    TmpLong:=0;
    Move(TmpAddr,TmpLong,4);
    If Result=0 then Writeln('DNS lookup failure');
   end;

if TmpLong=0 then
   begin
    Writeln;
    Writeln('Invalid Address was specified: '+#34,A,#34);
    Halt(2);
   end;
 NormVideo;
 Window(1,2,80,25);
 ClrScr;
 ShowStatusBar('STARTING-UP');
 Result:=MainNNTPGETART(ParamStr(1), ParamStr(2), TmpAddr, A);
 ShowTcpError('[EOP]');
 Writeln;
 If Result=0 then Writeln('Article Retreival Completed');

END.


