
Unit JPIRCCIN;        { JPIRC CurrentIN   buffer processing }

Interface

Uses ABI, ABI_JP, JP_UNIT, DOS, JPIRCWIN, JPIRCVAR, JPIRCDCC, XSTRING, ENCRYPT;

var
    Last10CTCPREQ : Array[1..10] of String;
    CTCPLoops     : Byte;
    OriginalBuffer: ^BufferREC;
    VerboseCTCP   : Boolean;

Procedure ProcessIncomingCIN_Buff;

Implementation

Var  TmpBuffer:BufferREC;
     I : Integer;
     TmpChar : Char;

Function lowQuote( msg: String):String;
var S :String;
Begin
  lowQuote:='';  S:='';
  For I:=1 to Length(msg) do
    Begin
      Case (msg[i]) of
        #0  : S:=S+^P+'0';
        #10 : S:=S+^P+'n';
        #13 : S:=S+^P+'r';
        ^P  : S:=S+^P+^P;
       ELSE
         S:=S+msg[i];
       END;
    End;
  lowQuote := Replace( S, ^P, '\020');
End;

Function lowDeQuote( tmpmsg: String):String;
var S :String;
    msg : String;
Begin
  lowDeQuote:='';  S:='';

  msg := Replace(tmpmsg, '\020', ^P );
  For I:=1 to Length(msg) do
    Begin
      Case (msg[i]) of
        ^P  : If i<Length(msg) then
                begin
                  Case (msg[i+1]) of
                    '0' : S:=S+#0;
                    'n' : S:=S+#10;
                    'r' : S:=S+#13;
                    ^P  : S:=S+^P;
                  End;
                end;
       ELSE
         S:=S+msg[i];
       END;


    End;
  lowDeQuote :=S;
End;

Function ctcpDequote( inmsg:String):String;
var S :string;
Begin
  ctcpDequote:='';  S:='';


  ctcpDequote := S;
End;


Function ProcessIncomingCTCP:Boolean;
var
 CSPos, CEPos, CNum : Word;
 A,B,C, V  : String;
 TmpStr : String;
 Result :Integer;
 I      :Integer;
 TmpLong : LongInt;
 ZS     : Byte;
 ShowCTCP : Boolean;
 CSecond:String[80];
 SubWin : Byte;
Begin
 SubWin:=CW;
 ProcessIncomingCTCP:=False;
 CSPos:=Inbuff(^A, CIN_Buff, 1);
 If (CSPos=0) or (CSPos=CIN_Buff.length) then   exit;

 ZS:=0;
{ WlnWrite(CW, '...'+CIN_Line+'...'); }

 If (UCase( Copy(CIN_Line,1, Pos(' ',CIN_Line)) ) ='PRIVMSG ') then ZS:=1;
 If (UCase( Copy(CIN_Line,1, Pos(' ',CIN_Line)) ) ='NOTICE ')  then ZS:=2;

 If ZS=0 then    exit;

 CSecond := PARSERFN( CIN_Line, 2);

 If CSecond<>UCase(User.Nick) then
   begin
     For I:=1 to MaxWindows do
        Begin
          If CSecond=UCase(CHA^[WindowA^[I].CCH].Name) then
              begin
                SubWin:=I;
                Break;
              end;
        End;
   end;


 CEPos:=Inbuff(^A, CIN_Buff, CSPos+1);
 A:=CopyBuff(CIN_Buff, CSPos+1, CEPos-CSPos -1);
 Last10CTCPREQ[CTCPLoops]:=A;
If IsScrLock then  WlnWrite(SubWin, '=CTCP===('+A+')');

 DeleteBuffer(CIN_Buff, CSPos, (CEPos-CSPos) { +1 });
 ProcessIncomingCTCP:=False;      {Will handle multiple some other time}

  C:=PARSERFN(A, 2);
  CNum :=PARSENFN(A);
  V:='';     ShowCTCP:=VerboseCTCP;
 Case ZS of
   1: Begin
       B:='';
       If Pos(' ', A)>0 then
           V:='REQCTCP '+PARSERFN(CIN_Line,2)+' '+A
                {Copy(A, 1, Pos(' ',A))+':'+Copy(A, Pos(' ',A), Length(A))}
         else
           V:='REQCTCP '+PARSERFN(CIN_Line,2)+' '+A;
       If Ucase(A)='FINGER' then
             begin
               B:='NOTICE '+CIN_PNick+' :'+^A+'FINGER Running '+
                            ClientName+' '+ClientVer+' by Tytarg'+^A;
               tcp_sendtextln(IRCS, B);
             end;
       If (Ucase(A)='BOBCAT') and (Ucase(ParamStr(1))='BOBCAT') then
           begin
             begin
               B :='NOTICE '+CIN_PNick+' :'+^A+'Yes jpIRC is running under Bobcat DOS WWW Browser'+^A;
               tcp_sendtextln(IRCS, B);
             end;
           end;
       If Ucase(A)='VERSION' then
             begin
               B:='NOTICE '+CIN_PNick+' :'+^A+'VERSION Running '+
                            ClientName+' '+ClientVer+' by Tytarg'+^A;
               B:='NOTICE '+CIN_PNick+' :'+^A+'VERSION Running '+X_N_CLN+^A;
               tcp_sendtextln(IRCS, B);
             end;
       If Ucase(A)='SOURCE' then
             begin
               B:='NOTICE '+CIN_PNick+' :'+^A+'SOURCE '+X_N_SPC+^A;
               tcp_sendtextln(IRCS, B);
             end;
       If Ucase(A)='USERINFO' then
             begin
               B:='NOTICE '+CIN_PNick+' :'+^A+'USERINFO '+User.UserInfo+^A;
               tcp_sendtextln(IRCS, B);
             end;
       If UCase(Copy(A,1,12))='CLIENTINFO' then
             begin
               B:='NOTICE '+CIN_PNick+' :'+^A+'CLIENTINFO '+User.ClientInfo+^A;
               tcp_sendtextln(IRCS, B);
             end;
       If UCase(Copy(A,1,7))='ERRMSG ' then
             begin
               asm nop end;
               If CNum=2 then
                   begin
                     B:='NOTICE '+CIN_PNick+' :'+^A+'ERRMSG '+PARSERFN(A,2);
                     B:=B+' :No problem';
                     B:=B+^A;    {not set}
                     tcp_sendtextln(IRCS, B);
                   end;
             end;
       If Ucase(Copy(A,1,5))='PING ' then
             begin
               B:='NOTICE '+CIN_PNick+' :'+^A+'PING '+Copy(A,6,Length(A)-5)+^A;
{               B:='NOTICE '+CIN_PNick+' : CTCP PING Unsupported';  }
               tcp_sendtextln(IRCS, B);
               asm nop end;
             end;
       If Ucase(Copy(A,1,5))='ECHO ' then
             begin
               B:='NOTICE '+CIN_PNick+' :'+^A+'ECHO '+Copy(A,6,Length(A)-5)+^A;
               tcp_sendtextln(IRCS, B);
             end;
       If Ucase(Copy(A,1,7))='ACTION ' then
             begin
               ShowCTCP:=False;
               B:='ACTION';
               TmpStr:= '* '+ CIN_PNick +' '+Copy(A, 8, Length(A)-7);
               WlnWrite(SubWin, TmpStr);
             end;
       If Ucase(Copy(A,1,4))='DCC ' then
             begin
               ShowCTCP:=False;
               B:='DCC';
               TmpStr:='*** DCC '+PARSERFN(A, 2)+' REQUEST from '+CIN_PNick;
               if CNum>2 then TmpStr:=TmpStr+' "'+PARSERFN(A, 3)+'"';
               WlnWrite(SubWin, TmpStr);
               ProcessDCC_IN( Copy(A,5,Length(A)-4));
             end;
       If Ucase(Copy(A,1,4))='SED ' then
             begin
               ShowCTCP:=False;
               B:='SED';
               If SED_Decrypt(CIN_PNick, Copy(A,5,Length(A)-4), TmpStr) then
                 begin
                   WlnWrite(SubWin, '*'+CIN_PNick+'*ENC: '+TmpStr);
                   WlnWrite(SubWin, 'Untranslated = "'+A+'"');
                 end else begin
                   TmpStr:='*** ENCRYPTED CTCP /MSG received from '+CIN_PNick;
                   if CNum>2 then TmpStr:=TmpStr+' "'+PARSERREST(A, 3)+'"';
                   WlnWrite(SubWin, TmpStr);
                 end;
               if CNum>2 then TmpStr:=TmpStr+' "'+PARSERREST(A, 3)+'"';
               WlnWrite(SubWin, TmpStr);
             end;
       If UCase(Copy(A,1,7))='PGPINFO' then
             begin
               ShowCTCP:=True;
               { ^APGPINFO keysize/id: finger print: where to get^A }
               B:='NOTICE '+CIN_PNick+' :'+^A+'PGPINFO ';
               B:=B+User.PGPINFO+^A;
               tcp_sendtextln(IRCS, B);
              end;
       If ShowCTCP then
            begin
              AddBuffer(CIN_Buff, 0, V);
           end else begin
              CIN_Buff.Length:=0;
            end;
        If (B='') and (CNum>0) then
            begin
               B:='NOTICE '+CIN_PNick+' :'+^A+'ERRMSG '+PARSERFN(A,1);
               B:=B+' :Unknown CTCP Query';
               B:=B+^A;    {not set}
               tcp_sendtextln(IRCS, B);
            end;
      End;
   2: Begin
       If Pos(' ', A)>0 then
              V:='REPCTCP '+C+' '+Copy(A, 1, Pos(' ',A) )+
                 ' :'+Copy(A, Pos(' ',A), Length(A));
       ShowCTCP:=True;
(***********
       If Ucase(Copy(A,1,8))='VERSION ' then
             begin
               AddBuffer(CIN_Buff, 0 , TmpStr);
               exit;
             end;
       If Ucase(Copy(A,1,5))='ECHO ' then
             begin
               TmpStr:='CTCP '+C+' :CTCP REPLY ECHO '+
                       ' from '+CIN_PNick+': '+Copy(A, 6, Length(A)-5 );
               AddBuffer(CIN_Buff, 0, TmpStr);
               exit;
             end;
************)
       If UCase(Copy(A,1,5))='PING ' then
           Begin
             ShowCTCP := False;
             V:=PARSERREST(A,2);
             If IsScrLock then  ShowUnixDate( TmpLong-ULVal(V) );
             WlnWrite(CW, '*** PING Reply from '+CIN_PNick+' is ');
             TmpLong:=GetUnixTime;
             Str( (TmpLong - ULVal(V)), V);
             WWrite(CW, V+' second(s).');
           End;
       If ShowCTCP then
            begin
              AddBuffer(CIN_Buff, 0, V);
           end else begin
              CIN_Buff.Length:=0;
            end;
      End;
  else
    WlnWrite(SubWin, '.x.'+CIN_Line+'.x.');
  end;

End;





Procedure ProcessIncomingCIN_Buff;
var
  W:Word;
  TmpStr:String;
Begin
 Move(CIN_Buff, OriginalBuffer^, SizeOf(OriginalBuffer^));
 CIN_prefix:='';
 CIN_PUser :='';  CIN_PHost:='';   CIN_PNick:='';  CIN_PAddr:='';
 If CIN_Buff.Buffer[1]=':' then
      begin
        W := Pos(' ', CIN_Line);
        CIN_prefix := Copy(CIN_Line, 2, W-1);
        W := Inbuff(' ', CIN_Buff, 1);
        If W=CIN_Buff.Length then
          begin
            Str(W, TmpStr);
            WlnWrite(CW, 'ERROR, Found bug in Line Reading area (prefix too long?)'+TmpStr);
            WlnAWrite(CW, CIN_Buff);
          end;
        DeleteBuffer(CIN_Buff, 1, W);

        CIN_Line:=ShowBuffer(CIN_Buff, 6 );
        If CIN_prefix<>'' then
           begin
              TmpStr:=CIN_prefix;
              If Pos('!',TmpStr)>0 then
                   begin
                      If Pos('@',TmpStr)>0 then
                            begin
                              W:=Pos('@', Copy(TmpStr, Pos('!',TmpStr)+1, Length(TmpStr)));
                              CIN_PUser := Copy(TmpStr, Pos('!',TmpStr)+1, W-1);
                              Delete(TmpStr, Pos('!',TmpStr), W);
                         end else begin
                              CIN_PUser := Copy(TmpStr, Pos('!',TmpStr)+1, Length( TmpStr));
                              Delete(TmpStr, Pos('!',TmpStr), Length(TmpStr)-Pos('!',TmpStr));
                            end;
                      If CIN_PUser[1]='~' then Delete(CIN_PUser,1,1);
                    end;
                 If Pos('@',TmpStr)>0 then
                        begin
                          CIN_PHost := Copy(TmpStr, Pos('@',TmpStr)+1, Length( TmpStr));
                          Delete(TmpStr, Pos('@',TmpStr), Length(CIN_PHost) +1 );
                        end;
                 If TmpStr[Length(TmpStr)]=' ' then Delete(TmpStr, Length(TmpStr) ,1);
                 If Pos('.',TmpStr)>0 then
                          CIN_PAddr:=Copy(TmpStr, 1, Length(TmpStr))
                        ELSE
                          CIN_PNick:=Copy(TmpStr, 1, Length(TmpStr));
                 While Copy(CIN_PHost,Length(CIN_PHost),1)=' ' do
                               CIN_PHost[0]:=Chr( Length(CIN_PHost)-1 );
          end;
      End;

 CTCPLoops:=0;

 Repeat
  Inc(CTCPLoops);


 Until  (not ProcessIncomingCTCP) or (CTCPLoops >9);


End;



var
  SaveExitProc:Pointer;

{$F+}
Procedure CIN_NewExitProc; far;
 begin
   ExitProc:=SaveExitProc;
   Dispose(OriginalBuffer);
 end;


BEGIN
  New(OriginalBuffer);
  SaveExitProc := ExitProc;
  ExitProc := @CIN_NewExitProc;

  FillChar(OriginalBuffer^, SizeOf(OriginalBuffer^), #0);
  FillChar(Last10CTCPREQ, SizeOf(Last10CTCPREQ), #0);
  VerboseCTCP:=True;
END.

