{$IFDEF OVERLAY}
{$O+}
{$ENDIF}
Unit JPIRCCMD;        { Commands from commandline }

Interface

Uses DOS,CRT,ABI,ABI_DOM,ABI_JP,JP_UNIT,XSTRING,MKScrn,
     JPIRCVAR,JPIRCWIN,JPIRC_IO, JPIRCDCC,
{$IFDEF OURICMP}
     JPI_ICMP,
{$ENDIF}
     JPIRCSET,
     ENCRYPT,SPAWNO,JPIRCHLP,IDENTD,JPIRC_HB,
     JPIEXCMD;

Procedure ProcessConsoleCMD;
Procedure OpenAndRegister;

Implementation

Procedure OpenAndRegister;
var Result:word;
    TmpStr:String;
Begin
      User.i := False;  User.s :=False;  User.w:=False;  User.o:=False;
      User.r := False;  User.IRCop :=False;  User.WeAway:=False;
      WlnWrite(CW,'*** Resolving '+User.servername);
      If not ip_lookup(User.servername, User.serverIP) then
             begin
               WWrite(CW,' - Unable to locate server: '+User.servername);
               exit;
            end else begin
               WWrite(CW,' - Found '+User.servername+' as '+IPTOASCII(User.serverIP));
             end;
        WlnWrite(CW,'*<>* attempting to connect to '+User.servername);
        Result:=Tcp_Open(IRCS, 0, User.serverIP, 0, User.serverPort, TcpOpenTime);
        if Result=no_error then WlnWrite(CW,'Connection Established');
        Str(Result,TmpStr);
        if Result<>0 then WlnWrite(CW,'Error connecting: '+TmpStr);
        If Result=err_timeout then WlnWrite(CW, '*** ERROR :   Timeout on Open');
        If Result=err_nohandles then WlnWrite(CW,'*** ERROR :   No tcp_handles');
        If Result=err_badsession then WlnWrite(CW,'*** ERROR :   Bad tcp_session');
        If (Result=err_nohandles) or (Result=err_badsession) then
             begin
              { Result:=Tcp_Close(CurSession,0,150); } {handle=00 if bad?}
              exit;
             end;
      User.RegdIn := False;
      If tcp_IsConnected(IRCS) then
           begin
            asm nop end;
                {registration: Pass, Nick, User}
                if User.Pass<>'' then tcp_sendtextln(IRCS, 'PASS '+User.Pass);
                tcp_sendtextln(IRCS, 'NICK '+User.Nick);
                tcp_sendtextln(IRCS, 'USER '+User.UserName+' '+User.HostName+' . :'+User.RealName);
            If result=0 then
              begin
                WlnWrite(CW, '*** Waiting for authorization from server.');
                User.RegdIn := True;
              end;
           end;
End;


Procedure ProcessWindowCMD(CLine:String);
var tX, tY, tA , tY1, tY2: Byte;
    tCW, tSY1, tSY2: Byte;
    TmpB:Boolean;
    CFirst:String[80];
    CSecond:String[80];
    CThird:String[80];
    CNum:Word;
    TmpStr:String;
    W:Word;
    I:Integer;
    Result:Integer;
    TmpSave:Pointer;
    TmpWord:Word;
Begin
  CNum   := PARSENFN(CLine);
  CFirst := UCase(PARSERFN(CLine, 1));
  CSecond:= UCase(PARSERFN(CLine, 2));
  CThird := UCase(PARSERFN(CLine, 3));
If CFirst='KILL' then
     begin
       If CW=1 then
          begin
           WlnWrite(CW,'*!* You cannot kill Window [1]');
         end else begin
           tCW:=CW;
           For W:=1 to MaxWindows do
             Begin
               If (WindowA^[tCW].Y1=WindowA^[W].SY2+1) and (WindowA^[W].SY2<>0) then
                 begin
                  WindowA^[W].Y2:=WindowA^[tCW].Y2;
                  WindowA^[W].SY1:=WindowA^[tCW].SY1;
                  WindowA^[W].SY2:=WindowA^[tCW].SY2;
                  break;
                 end;
             End;
           CW:=W;
           If tCW<>CW then
             begin
               For W:=WindowA^[tCW].Y1 to WindowA^[tCW].Y2 do
                  begin
                    AbsGotoXY(1, W);
                    ClrEol;
                  end;
               FillChar(WindowA^[tCW], SizeOf(WindowA^[tCW]), #0);
             end;
          end;
       exit;      {Insert a redraw command around here somewhere}
     end;
If CFirst='NEW' then
     Begin
       TmpB:=False;
       For W:=1 to MaxWindows do
          begin
           If WindowA^[W].Y1=0 then
             begin
               TmpB:=True;
               Break;
             end;
          end;
       If not TmpB then
         begin
           WlnWrite(CW,'*** All Window Handles full -Not enough Window handles available');
        end Else begin
           tCW:=CW;  CW:=W;
           WindowA^[CW].SplitFrom:=tCW;
           tY2:=Trunc( (WindowA^[tCW].Y2 - WindowA^[tCW].Y1) /2);
           tY1:=WindowA^[tCW].Y1;

           { Insert HERE a SAVE Window area then RESTORE it in the other place }
           { using the new Y1 }
(*******
           TmpWord:=MySaveScrnRegion(1, WindowA^[tCW].Y1, 80, WindowA^[tCW].Y2, TmpSave);
*******)
           If TmpWord<>0 then
               begin
           {old}  WindowA^[tCW].Y1:=tY2+1;  { WindowA^[tCW].Y2:=     ; }
                  WindowA^[tCW].CY:=(tY2-1 ) + WindowA^[tCW].CY;
                  If WindowA^[tCW].CY> WindowA^[tCW].Y2 then WindowA^[tCW].CY:=WindowA^[tCW].Y2;

(*******
                  MyRestoreScrnRegion(1, WindowA^[tCW].Y1, 80, WindowA^[tCW].Y2, TmpSave, TmpWord);
*******)
           {the}  WindowA^[CW].Y1:=tY1;  WindowA^[CW].Y2:=tY2-1;
           {new}  WindowA^[CW].CX:=1;    WindowA^[CW].CY:=WindowA^[CW].Y1;
                  WindowA^[CW].SY1:=tY2; WindowA^[CW].SY2:=tY2;
                  WindowA^[CW].tA :=7;

                  For W:=WindowA^[CW].Y1 to WindowA^[CW].Y2 do
                             begin
                               AbsGotoXY(1,W);
                               ClrEol;
                             end;

              end else begin
                  CW:=tCW;
                  WlnWrite(CW, '!!! Insufficient Memory to create new Window');
               end;
         end;
       exit;
     End;
If CFirst='NEXT' then
  begin
    For W:=CW+1 to MaxWindows do
       begin
         If WindowA^[W].Y1<>0 then break;
       end;
    If WindowA^[W].Y1=0 then W:=1;
    CW:=W;
  end;
End;

Procedure PickAServer(CLine:String);
var IRCDFile: text;
    A,B,C,TmpStr:String;
    TmpB:Boolean;
    TmpW:Word;
Begin
   A:='';  B:='';
If CLine='' then
 Begin
   WlnWrite(CW,'   - Server list:');
   WlnWrite(CW,' ');
   Assign(IRCDFile, 'SERVERS.IRC');
   Reset(IRCDFile);
    WlnWrite(CW,'  Server Address        Port Number        Short Desc.    ');
    repeat
      Readln(IRCDFile,A);
      B:=Copy(A,1,1);
      If (B<>'#') and (B<>'=') then
        begin
          WlnWrite(CW,'  "'+PARSERFN(A,1)+'"    '+PARSERFN(A,2));
          WWrite(CW,'     ['+PARSERFN(A,3)+']');
        end;
    until EOF(IRCDFile);
   Close(IRCDFile);
   WlnWrite(CW,'---');
  exit;
 End;

   If IRCS.Openned then
     begin
       WWrite(CW,'attempting to close current server connection');
       Result:=tcp_Close(IRCS,0,350);
       If Result<>0 then
         begin
            WWrite(CW,' - ERROR');
            exit;
         end;
     end;
    TmpStr:=PARSERFN(CLine,2);
    Val(TmpStr,TmpW,Result);
    If Result<>0 then TmpW:=6667;
    C:=PARSERFN(CLine,1);

    B:='';
    Assign(IRCDFile,'SERVERS.IRC');
    Reset(IRCDFile);
     repeat
       Readln(IRCDFile,A);
       If Copy(A,1,1)<>'#' then
        begin
           If Copy(A,1,1)='=' then
             Begin

               B:=PARSERFN(A,1);
               B:=Copy(B,2,Length(B));
               If UCase(B)=UCase(C) then
                 begin
                   C:=PARSERFN(A,3);
                   Val(C, TmpW, Result);
                   If Result<>0 then TmpW:=6667;
                   C:=PARSERFN(A,2);
{                   B:=C; }
                 end;
               B:='';
            End Else Begin
               If UCase(PARSERFN(A,1))=UCase(C) then
                 begin
                   C:=PARSERFN(A,2);
                   Val(C, TmpW, Result);
                   If (Result<>0) or (TmpW=0) then TmpW:=6667;
                   C:=PARSERFN(A,1);
                   B:=PARSERFN(A,3);
                   If B='' then B:=C;
                   break;
                 end;
             End;
        end;
     until EOF(IRCDFile);
    Close(IRCDFile);

    If (B='') and BeStrictD then
         begin
           WlnWrite(CW,' Unknown server "'+PARSERFN(CLine,1)+'"');
           exit;
        end else begin
           User.ServerName:=C;
           User.ServerPort:=TmpW;
         end;

    OpenAndRegister;

End;




Procedure ProcessConsoleCMD;
var  CFirst  : String[80];
     CSecond : String[80];
     CThird  : String[80];
     TmpStr  : String;
     A       : String;
     CNum    : Word;
     W:Word;
     TmpB    : Boolean;
     TmpIP   : IPAddr;
BEGIN
If (not CCmdValid) or (Length(CCmd)=0) then
  Begin
   JP_Idle;
   exit;
  End;
CNum   := PARSENFN(CCmd);
CFirst := UCase(PARSERFN(CCmd, 1));
CSecond:= UCase(PARSERFN(CCmd, 2));
CThird := UCase(PARSERFN(CCmd, 3));
If (Copy(CCmd,1,1)<>'/') or (CFirst='SAY') then
  Begin
   If (CFirst='SAY') then CCmd:=PARSERREST(CCmd, 2);
   If (Online) and (WindowA^[CW].CCH<>0) and (CHA^[WindowA^[CW].CCH].Name<>'')  then
         Begin
            TmpStr:=CCmd;
            If SED_Encrypt( CHA^[WindowA^[CW].CCH].Name, CCmd, TmpStr) then
              begin
                WlnWrite(CW,'DEBUG: Sending next encrypted');
                tcp_sendtextln(IRCS, 'PRIVMSG '+CHA^[WindowA^[CW].CCH].Name+' :'+
                                     ^A+'SED '+TmpStr+^A);
              end else begin
                tcp_sendtextln(IRCS, 'PRIVMSG '+CHA^[WindowA^[CW].CCH].Name+' :'+CCmd);
              end;
         End;
   if (IRCS.Result=0) and online then
     begin
       WlnWrite(CW,'<'+User.Nick+'> ');
       WWrite(CW,CCmd);
     end;
   Exit;
  End;
Delete(CFirst,1,1);
 If CFirst ='A' then
      begin
        WlnWrite(CW,'-- Active Channel listing');
        For W:=1 to MaxChannels do
          begin
            If CHA^[W].Name<>'' then
                  begin
                    TmpStr:='   '+CHA^[W].Name+'  ';
                    WlnWrite(CW,TmpStr);
                    If CHA^[W].p then WWrite(CW, 'p');
                    If CHA^[W].s then WWrite(CW, 's');
                    If CHA^[W].i then WWrite(CW, 'i');
                    If CHA^[W].t then WWrite(CW, 't');
                    If CHA^[W].n then WWrite(CW, 'n');
                    If CHA^[W].m then WWrite(CW, 'm');
                    Str(CHA^[W].UserLimit, TmpStr);
                    TmpStr:=' '+TmpStr+' "'+CHA^[W].Key+'"';
                    WWrite(CW, TmpStr);
                    WlnWrite(CW,'          '+CHA^[W].Topic);
                  end;
          end;
        WlnWrite(CW,'--- End of listing');
        exit;
      end;
 If CFirst ='QUIT' then
     Begin
      TmpStr:=PARSERREST(CCmd, 2);
      If not Online then DoExit:=True;
      If ExitFirstQuit then DoExit:=True;
      If not Online then WlnWrite(CW,'*** JPIRC - Exitting IRC client');
      If Online then WlnWrite(CW,'*** JPIRC - Closing connection with server');
      If Online then tcp_sendtextln(IRCS, 'QUIT :'+TmpStr);
      If IRCS.Openned then tcp_Close(IRCS, 0, 250);
      InitDisplay;
      FillChar(CHA^, SizeOf(CHA^), #0);
      Online:=tcp_IsConnected(IRCS);
      User.RegdIn := False;
      exit;
     End;
 If CFirst ='JOIN' then
     Begin
       If Online then tcp_sendtextln(IRCS, 'JOIN '+PARSERREST(CCmd,2));
       exit;
     End;
 If CFirst ='PART' then
     Begin
       TmpStr:=PARSERREST(CCmd,2);
       If TmpStr='*' then TmpStr:=CHA^[WindowA^[CW].CCH].Name;
       If Online then tcp_sendtextln(IRCS, 'PART '+TmpStr);
       exit;
     End;
 If CFirst ='/' then
     Begin
       If LastPRIVMSG='' then exit;
       If Online then tcp_sendtextln(IRCS, 'PRIVMSG '+LastPRIVMSG+' :'+PARSERREST(CCmd,2));
       If (IRCS.Result=0) and Online then
                 WlnWrite(CW, '=> *'+LastPRIVMSG+'* '+PARSERREST(CCmd,2));
       Exit;
     End;
 If CFirst ='MSG' then
     Begin
       TmpStr:=PARSERFN(CCmd,2);
       If Copy(TmpStr,1,1)='=' then
         Begin
          Delete(TmpStr,1,1);
          DTo:=TmpStr;
          DMsg:=PARSERREST(CCmd,3);
          exit;
         End;
       If (TmpStr='*') then TmpStr:=CHA^[WindowA^[CW].CCH].Name;
       LastPRIVMSG:=TmpStr;
       If SED_Encrypt( TmpStr, PARSERREST(CCmd, 3), A) then
           begin
             TmpStr := 'PRIVMSG '+TmpStr+' :'+^A+'SED '+A+^A;
             WlnWrite(CW,'DEBUG: Sending next encrypted');
             WlnWrite(CW,'ENC = '+A);
           end else begin
             TmpStr := 'PRIVMSG '+TmpStr+' :'+PARSERREST(CCmd, 3);
           end;
       If Online then tcp_sendtextln(IRCS, TmpStr);
       if Online { and (IRCS.Result=0)} then
          begin
            WlnWrite(CW,'-> *'+PARSERFN(CCmd,2)+'* '+PARSERREST(CCmd,3));
          end;
       exit;
     End;
 If CFirst ='NOTICE' then
     Begin
       TmpStr:=PARSERFN(CCmd,2);
       If (TmpStr='*') then TmpStr:=CHA^[WindowA^[CW].CCH].Name;
       If Online then tcp_sendtextln(IRCS, 'NOTICE '+TmpStr+' :'+PARSERREST(CCmd,3));
       if (IRCS.Result=0) and online then
          begin
            WlnWrite(CW,'-> -'+PARSERFN(CCmd,2)+'- '+PARSERREST(CCmd,3));
          end;
       exit;
     End;
 If CFirst ='AWAY' then
     Begin
      If Online then tcp_sendtextln(IRCS, 'AWAY :'+PARSERREST(CCmd,2));
      exit;
     End;
 If CFirst ='ISON' then
     Begin
      If Online then tcp_sendtextln(IRCS, 'ISON '+PARSERREST(CCmd,2));
      exit;
     End;
 If CFirst ='VERSION' then
     Begin
      WlnWrite(CW,'*** Client: '+OurVersion);
      If Online then tcp_sendtextln(IRCS, 'VERSION '+PARSERREST(CCmd,2));
      exit;
     End;
 If CFirst ='LIST' then
     Begin
      If Online then tcp_sendtextln(IRCS, 'LIST '+PARSERREST(CCmd,2));
      exit;
     End;
 If CFirst ='TOPIC' then
     Begin
      TmpStr:=PARSERFN(CCmd,2);
      If (TmpStr='*') then TmpStr:=CHA^[WindowA^[CW].CCH].Name;
      If Online and (TmpStr='') and (CHA^[WindowA^[CW].CCH].Name<>'') then
            begin
             tcp_sendtextln(IRCS, 'TOPIC '+CHA^[WindowA^[CW].CCH].Name);
             exit;
            end;
      If Online and ((Copy(TmpStr,1,1)='#') or (Copy(TmpStr,1,1)='&')) then
                       tcp_sendtextln(IRCS, 'TOPIC '+TmpStr+' :'+PARSERREST(CCmd,3));
      If Online and ((Copy(TmpStr,1,1)<>'#') and (Copy(TmpStr,1,1)<>'&')) then
                       tcp_sendtextln(IRCS, 'TOPIC '+CHA^[WindowA^[CW].CCH].Name+' :'+PARSERREST(CCmd,2));
      exit;
     End;
 If CFirst ='NAMES' then
     Begin
      TmpStr:=PARSERREST(CCmd,2);
      If TmpStr='*' then TmpStr:=CHA^[WindowA^[CW].CCH].Name;
      If TmpStr='' then
          Begin
            For I:=1 to MaxChannels do
               begin
                 If CHA^[I].Name<>'' then TmpStr:=TmpStr+CHA^[I].Name+' ';
               end;
          End;
      If Online then tcp_sendtextln(IRCS, 'NAMES '+TmpStr);
      exit;
     End;
 If CFirst ='INVITE' then
     Begin
      TmpStr:=PARSERFN(CCmd,2);
      If TmpStr='*' then TmpStr:=CHA^[WindowA^[CW].CCH].Name;
      TmpStr:=TmpStr+' '+PARSERREST(CCmd,3);
      If Online then tcp_sendtextln(IRCS, 'INVITE '+TmpStr);
      exit;
     End;
 If CFirst ='KICK' then
     Begin
       TmpStr:=PARSERFN(CCmd,2);
       If TmpStr='*' then TmpStr:=CHA^[WindowA^[CW].CCH].Name;
       TmpStr:=TmpStr+' '+PARSERREST(CCmd,3);
       If Online then tcp_sendtextln(IRCS, 'KICK '+TmpStr);

{      If Online then tcp_sendtextln(IRCS, 'KICK '+PARSERREST(CCmd,2)); }
      exit;
     End;
 If CFirst ='WALLOPS' then
     begin
      TmpStr:=PARSERREST(CCmd,2);
      If Online then tcp_sendtextln(IRCS, 'WALLOPS :'+TmpStr);
      exit;
     end;
 If CFirst ='ADMIN' then
     begin
      TmpStr:=PARSERREST(CCmd,2); { [server] }
      If Online then tcp_sendtextln(IRCS, 'ADMIN '+TmpStr);
      exit;
     end;
 If CFirst ='SUMMON' then
     begin
      If Online then tcp_sendtextln(IRCS, 'SUMMON '+PARSERREST(CCmd,2));
      exit;
     end;
 If CFirst ='USERS' then
     begin
      If Online then tcp_sendtextln(IRCS, 'USERS '+PARSERREST(CCmd,2));
      exit;
     end;
 If CFirst ='OPER' then
     begin
      If Online then tcp_sendtextln(IRCS, 'OPER '+PARSERREST(CCmd,2));
      exit;
     end;
 If (CFirst ='PASS') then
     begin
      WlnWrite(CW, '*** jpIRC does not implement Server-To-Server commands.');
      WlnWrite(CW, '***  If you really need to send such a command then just use /QUOTE instead.');
      exit;
     end;
 If CFirst ='CONNECT' then     { IRCop command }
     begin
      { targetserver [port [remoteserver]] }
      If Online then tcp_sendtextln(IRCS, 'CONNECT '+PARSERREST(CCmd,2));
      exit;
     end;
 If CFirst ='CLOSE' then
     begin
      If Online then tcp_sendtextln(IRCS, 'CLOSE '+PARSERREST(CCmd,2));
      exit;
     end;
 If CFirst ='HSAH' then
     begin
      If Online then tcp_sendtextln(IRCS, 'HSAH '+PARSERREST(CCmd,2));
      exit;
     end;
 If CFirst ='REHASH' then
     begin
      If Online then tcp_sendtextln(IRCS, 'REHASH');
      exit;
     end;
 If CFirst ='RESTART' then
     begin
      If Online then tcp_sendtextln(IRCS, 'RESTART');
      exit;
     end;
 If CFirst ='SQUIT' then
     begin
      WlnWrite(CW, '*** jpIRC does not currently completely implement SQUIT yet');
      exit;
     end;
 If CFirst ='USERHOST' then
     begin
      If Online then tcp_sendtextln(IRCS, 'USERHOST '+PARSERREST(CCmd,2));
      exit;
     end;
 If CFirst ='TRACE' then
     begin
      If Online then tcp_sendtextln(IRCS, 'TRACE '+PARSERREST(CCmd,2));
      exit;
     end;
 If CFirst ='STATS' then
     Begin
      If Online then tcp_sendtextln(IRCS, 'STATS '+PARSERREST(CCmd,2));
      exit;
     End;
 If CFirst ='LINKS' then
     Begin
      If Online then tcp_sendtextln(IRCS, 'LINKS '+PARSERREST(CCmd,2));
      exit;
     End;
 If (CFirst ='TIME') or (CFirst='DATE') then
     Begin
      If Online then tcp_sendtextln(IRCS, 'TIME '+PARSERREST(CCmd,2));
      exit;
     End;
 If CFirst ='INFO' then
     Begin
      If Online then tcp_sendtextln(IRCS, 'INFO '+PARSERREST(CCmd,2));
      exit;
     End;
 If (CFirst ='QUOTE') OR (CFirst='RAW') OR (CFirst='OUT')  then    { 13-jan-1999 }
     Begin
      If Online then tcp_sendtextln(IRCS, PARSERREST(CCmd,2));
      exit;
     End;
 If CFirst ='WHOIS' then
     Begin
      TmpStr:=PARSERREST(CCmd,2);
      If TmpStr='*' then TmpStr:=CHA^[WindowA^[CW].CCH].Name;
      If (TmpStr='*') or (TmpStr='') then
        begin
          WlnWrite(CW, '*** I wouldn''t do that if I were you');
          exit;
        end;
      If Online then tcp_sendtextln(IRCS, 'WHOIS '+TmpStr);
      exit;
     End;
 If CFirst ='KILL' then
     Begin
      If PARSERREST(CCmd,2)='' then exit;
      If Online then tcp_sendtextln(IRCS, 'KILL '+PARSERREST(CCmd,2));
      exit;
     End;
 If CFirst ='PING' then
     Begin
      If PARSERFN(CCmd,2)='' then exit;
      TmpStr:='PRIVMSG '+PARSERFN(CCmd,2)+' :'+^A+'PING '+ULStr(GetUnixTime)+^A;
      If Online then tcp_sendtextln(IRCS, TmpStr);
      exit;
     End;
 If CFirst ='WINDOW' then
     Begin
      ProcessWindowCMD(PARSERREST(CCmd,2));
      exit;
     End;
 If (CFirst ='CLS') or (CFirst='CLEAR') then
     Begin
      If CSecond='-RESET' then InitDisplay;
      For W:=WindowA^[CW].Y1 to WindowA^[CW].Y2 do
         begin
          AbsGotoXY(1, W);
          ClrEol;
         end;
      WindowA^[CW].CX:=1;  WindowA^[CW].CY:=WindowA^[CW].Y1;
      ShowStatusLine(CW, '');
      exit;
     End;
 If (CFirst ='MODE') then
     Begin
       If Online then
          begin
           TmpStr:=PARSERFN(CCmd,2);
           If TmpStr='*' then TmpStr:=CHA^[WindowA^[CW].CCH].Name;
           If TmpStr='' then exit;
           tcp_sendtextln(IRCS, 'MODE '+TmpStr+' '+PARSERREST(CCmd,3)); { Trying without the : }
           exit;
          end;
       exit;

     End;
 If CFirst ='HELP' then
     Begin
      ProcessHelpLine(PARSERREST(CCmd, 2));
{      WlnWrite(CW,'!            #            :            ABORT        ADMIN'); }
      exit
     End;
 If CFirst ='LUSERS' then
     Begin
      tcp_sendtextln(IRCS, 'LUSERS '+PARSERREST(CCmd, 2));
      exit;
     End;
 If CFirst ='MOTD' then
     Begin
      tcp_sendtextln(IRCS, 'MOTD');
      exit;
     End;
 If CFirst ='DNS' then
     Begin
      tcp_sendtextln(IRCS, 'DNS '+PARSERREST(CCmd, 2));
      exit;
     End;
 If CFirst ='NICK' then
     Begin
{
      If Length(CSecond)>9 then
         WlnWrite(CW,'*** Nick longer than 8 letters, Nick truncated to: '+Copy(PARSERFN(CCmd,2),1,9));
      User.Nick:=Copy(PARSERFN(CCmd,2),1,9);
}
      If Length(CSecond)>30 then
         WlnWrite(CW,'*** Nick longer than 30 letters, Nick truncated to: '+Copy(PARSERFN(CCmd,2),1,9));
      User.Nick:=Copy(PARSERFN(CCmd,2),1,30);
      If ( PARSERREST(CCmd,2)='') or (not Online) then exit;

      tcp_sendtextln(IRCS, 'NICK '+User.Nick);
      ShowStatusLine(CW,'sent nickreq '+Copy(PARSERFN(CCmd,2),1,30));
      exit;
     End;
 If CFirst ='SERVER' then
     Begin
      User.Pass := '';
      TmpStr := PARSERREST(CCmd,2);
      If Copy(CSecond,1,3) = '/P=' then
        begin
          User.Pass := Copy(PARSERFN(CCmd, 2), 4, 30);
          TmpStr := PARSERREST(CCmd,3);
{$IFDEF DEBUG}
          WlnWrite(CW, 'Password set to "'+User.Pass+'"');
{$ENDIF}
        end;
      WlnWrite(CW,'*** JPIRC v0.9a ');
      If CNum=1 then
        Begin
          If Online then
           begin
            WlnWrite(CW,' Current Server = '+User.ServerName+' '+LeadingZero(User.ServerPort,2));
           end else begin
            WlnWrite(CW,' Current Server = none');
           end;
          Str(DefaultPort, TmpStr);
          WlnWrite(CW,' Default Server = '+DefaultServer+' '+TmpStr);
          WlnWrite(CW,' ');
          PickAServer('');
{          Assign('SERVERS.TXT' }
          exit;
        End;

      PickAServer(TmpStr);
      exit;
     End;
 If CFirst ='WHO' then
     Begin
       TmpStr:=PARSERREST(CCmd,2);
       If TmpStr='*' then TmpStr:=CHA^[WindowA^[CW].CCH].Name;
       If TmpStr='' then exit;
       If Online then tcp_sendtextln(IRCS, 'WHO '+TmpStr);
       exit;
     End;
 If CFirst ='DESCRIBE' then
     Begin
       TmpStr:=PARSERFN(CCmd,2);
       If (PARSERREST(CCmd,2)='') then exit;
       If TmpStr='*' then TmpStr:=CHA^[WindowA^[CW].CCH].Name;
       TmpStr:='PRIVMSG '+TmpStr+' :'+^A+'ACTION '+PARSERREST(CCmd,3)+^A;
       If Online then tcp_sendtextln(IRCS, TmpStr);
       WlnWrite(CW,'>!'+PARSERFN(CCmd,2)+'* '+User.Nick+' '+PARSERREST(CCmd,3));
       exit;
     End;
 If CFirst ='ME' then
     Begin
       TmpStr:=PARSERREST(CCmd,2);
       If TmpStr='' then exit;
       TmpStr:='PRIVMSG '+CHA^[WindowA^[CW].CCH].Name+' :'+^A+'ACTION '+TmpStr+^A;
       If Online then tcp_sendtextln(IRCS, TmpStr);
       WlnWrite(CW,'* '+User.Nick+' '+PARSERREST(CCmd,2));
       exit;
     End;
 If CFirst ='WHOWAS' then
     Begin
       TmpStr:=PARSERREST(CCmd,2);
       If TmpStr='*' then TmpStr:=CHA^[WindowA^[CW].CCH].Name;
       If TmpStr='' then exit;
       If Online then tcp_sendtextln(IRCS, 'WHOWAS '+TmpStr);
       exit;
     End;
{ Newer IRC commands }
 If CFirst ='MAP' then                                         { *NEW* }
     Begin
      tcp_sendtextln(IRCS, 'MAP '+PARSERREST(CCmd, 2));
      exit;
     End;
 If CFirst ='KLINE' then                                       { *NEW* }
     Begin
      tcp_sendtextln(IRCS, 'KLINE '+PARSERREST(CCmd,2));
      exit;
     End;
 If CFirst ='TKLINE' then                                      { *NEW* }
     Begin
      tcp_sendtextln(IRCS, 'TKLINE '+PARSERREST(CCmd,2));
      exit;
     End;
 If CFirst ='UMODE' then                                       { *NEW* }
     Begin
      tcp_sendtextln(IRCS, 'UMODE '+PARSERREST(CCmd,2));
      exit;
     End;
 If CFirst ='RECONNECT' then                                   { *NEW* }
     Begin
      tcp_sendtextln(IRCS, 'RECONNECT '+PARSERREST(CCmd,2));
      exit;
     End;
 If CFirst ='SERVICE' then                                     { *NEW* }
     Begin
      tcp_sendtextln(IRCS, 'SERVICE '+PARSERREST(CCmd,2));
      exit;
     End;
 If CFirst ='SQUERY' then                                      { *NEW* }
     Begin
      tcp_sendtextln(IRCS, 'SQUERY '+PARSERREST(CCmd,2));
      exit;
     End;
 If CFirst ='SERVLIST' then                                    { *NEW* }
     Begin
      tcp_sendtextln(IRCS, 'SERVLIST '+PARSERREST(CCmd,2));
      exit;
     End;
 If CFirst ='HAZH' then                                        { *NEW* }
     Begin
      tcp_sendtextln(IRCS, 'HAZH '+PARSERREST(CCmd,2));
      exit;
     End;
 If CFirst ='DIE' then                                         { *NEW* }
     Begin
      tcp_sendtextln(IRCS, 'DIE '+PARSERREST(CCmd,2));
      exit;
     End;

{TO BE Local only commands }
  If (CFirst='CD') or (CFirst='CHDIR') then
       Begin
        If CNum=2 then
            begin
             TmpStr:=PARSERREST(CCmd,2);
{$I-}        ChDir(TmpStr);
             If IOResult=0 then
                  begin
                     GetDir(0,TmpStr);
                     WlnWrite(CW, '*** Directory changed to '+TmpStr);
                 end else begin
                     WlnWrite(CW, '*** Cannot change Directory to "'+TmpStr+'"');
                  end;
{$I+}
           end else begin
             GetDir(0,TmpStr);
             WlnWrite(CW, '*** Current directory: '+TmpStr);
            end;
        exit;
       End;
 If (CFirst ='CTCP') and (CSecond<>'') then
     Begin
       TmpStr:='PRIVMSG '+PARSERFN(CCmd,2)+' :'+^A+UCase(PARSERREST(CCmd,3))+^A;
       If (CSecond='*') or (PARSERREST(CCmd,3)='') then exit;
       If Online then tcp_sendtextln(IRCS, TmpStr);
       exit;
     End;

 If (CFirst = 'ST') or (CFirst='STATUS') then
     Begin
       If CSecond='HB' then
           begin
             WlnWrite(CW, '___ <HeartBeat Status Report> ___');
             HBStatReport;
             exit;
           end;
       If CSecond='CFG' then
           begin
             WlnWrite(CW, '___ <CFG Status report> ___');
             WlnWrite(CW, ' ');
             WlnWrite(CW, ' INI Filename = '+INIFileName);
             If UCase(ParamStr(1))='BOBCAT' then WlnWrite(CW, ' Currently Running under BobCat ');
             WlnWrite(CW, ' Nick         = "'+User.Nick+'"');
             WlnWrite(CW, ' UserName     = "'+User.UserName+'"');
             WlnWrite(CW, ' RealName     = "'+User.RealName+'"');
             WlnWrite(CW, ' HostName     = "'+User.HostName+'"');
             WlnWrite(CW, ' IP Address   = '+IPTOASCII(TcpDrvInfo.myip));
             WlnWrite(CW, ' GATEWAY      = '+IPTOASCII(TcpDrvInfo.gateway));
             WlnWrite(CW, ' NETMASK      = '+IPTOASCII(TcpDrvInfo.netmask));
             WlnWrite(CW, ' DNS          = '+IPTOASCII(TcpDrvInfo.dnsserver));
             WlnWrite(CW, ' TIMESERVER   = '+IPTOASCII(TcpDrvInfo.timeserver));
            exit;
           end;
       WlnWrite(CW, '___ <System Status report> ___');
       WlnWrite(CW, '  CPU Type              = '+CPUName);
       If Online then TmpStr:='Yes'  else TmpStr:='No';
       WlnWrite(CW, '  IRC Server Connected? = '+TmpStr);
       WlnWrite(CW, 'Current Server          = '+User.servername);
       WlnWrite(CW, '                        = '+IPTOASCII(User.serverIP));
       WlnWrite(CW, '                   Nick = "'+User.Nick+'"');
       Str(MemAvail, A);
       WlnWrite(CW, '  Heap Memory Available = '+A+' bytes');
       Str($FFFF-Ofs(SaveInt75), A);
       WlnWrite(CW, ' Data Segment Available = '+StrHex($FFFF-Ofs(SaveInt75),4)+' ('+A+' bytes)');
       WlnWrite(CW, '      Last PRIVMSG user = '+LastPRIVMSG);
       Str(IDENTDState, A);
       WlnWrite(CW, '     IDENTDState  (~0)  = '+A);
       Str(TcpDrvInfo.def_ttl, A);
       WlnWrite(CW, '     Default TTL  (60)  = '+A);
       Str(TcpDrvInfo.def_tos, A);
       WlnWrite(CW, '     Default TOS  ( 0)  = '+A);

       ProcessIEX_CMD(CCmd);
       WlnWrite(CW, '~~~ <End of Status Report> ~~~');
       exit;
     End;
 If (CFirst = 'EXEC') then
     Begin
       If CSecond='-SWAP' then
         begin
           {SwapVectors;}
            If CThird='' then  Result:= spawn(GetEnv('COMSPEC'), '', 0)
                         else  Result:= spawn(GetEnv('COMSPEC'), '/C '+PARSERREST(CCmd,3), 0);
            str(Result, TmpStr);
            If Result=-1 then
              begin
                case spawno_error of
                   enotfound : WlnWrite(CW, 'File not found');
                   enopath   : WlnWrite(CW, 'Invalid Path');
                   eaccess   : WlnWrite(CW, 'Access denied');
                   enomem    : WlnWrite(CW, 'Insufficient Memory Available');
                   e2big     : WlnWrite(CW, 'Too Big');
                   ewritefault : WlnWrite(CW, 'Write Fault!');
                 end;
              end else WlnWrite(CW, 'Errorlevel: '+TmpStr);
           {SwapVectors;}
         end else begin
            SwapVectors;
             If (CSecond='') then   Exec(GetEnv('COMSPEC'), '')
                             else   Exec(GetEnv('COMSPEC'), '/C '+PARSERREST(CCmd,2));
            SwapVectors;
         end;
       exit;
     End;
 If CFirst ='DMSG' then
     begin
      TmpStr:='MSG '+PARSERREST(CCmd,2);
      ProcessDCC_CMD(TmpStr);
      exit;
     end;
 If CFirst ='DCC' then
     begin
       ProcessDCC_CMD(PARSERREST(CCmd, 2));
       exit;
     end;
 If (CFirst ='NSLOOKUP') and (CSecond<>'') then
     begin
       TmpStr := PARSERFN(CCmd, 2);
       WlnWrite(CW,'*** Resolving '+TmpStr);
       Result :=resolve(TmpStr, TmpIP, 0);
       If Result=0 then WlnWrite(CW, 'Error with Resolve   '+DomainExtra+'  '+DomainError);
       If Result>0 then
         Begin
           WlnWrite(CW,'*** Result of Resolve():  '+TmpStr+' = '+IPTOASCII(TmpIP));
         End;
       exit;
     end;
 If CFirst ='SET' then
     begin
       ProcessSetCMD(PARSERREST(CCmd,2));
       exit;
     end;
 If CFirst ='HISTORY' then
     Begin
       WlnWrite(CW, '--- Command History:');
       For I:=0 to 15 do WlnWrite(CW, History^[I]);
       exit;
     End;
{$IFDEF OURICMP}
 If CFirst ='ICMPPING' then
   Begin
     CSecond:=PARSERFN(CCmd, 2);
     WlnWrite(CW, 'Looking up '+CSecond);
     If ip_lookup(CSecond, TmpIP) then
       begin
         WlnWrite(CW, 'PINGING '+IPTOASCII(TmpIP));
         If SendPing(0, TmpIP) then WWrite(CW, ' Verified send');
       end;
     exit;
   End;
{$ENDIF}
 If CFirst ='FINGER' then
   Begin
    ProcessIEX_CMD(CCmd);
    Exit;
   End;
 If CFirst ='MORE' then
   Begin
    ProcessIEX_CMD(CCmd);
    exit;
   End;

 If CFirst ='GO' then
   Begin
    ProcessIEX_CMD(CCmd);
    exit;
   End;
 If CFirst = 'ENCRYPT' then
   Begin
    Case CNum of
      0 :;
      1 : Begin { /encrypt }
            DoListEncrypt(1);
          End;
      2 : Begin { /encrypt who }
            If DoDelEncrypt( PARSERFN(CCmd, 2) ) then
              WlnWrite(CW, 'Key for user '+PARSERFN(CCmd,2)+' deleted');
          End;
    Else
        { /encrypt who key }
          If DoInsEncrypt( PARSERFN(CCmd, 2), 0, PARSERREST(CCmd,3) ) then
          WlnWrite(CW, 'Key set for user '+PARSERFN(CCmd,2));
    End;
    exit;
   End;
 If CFirst = 'NOTIFY' then
   Begin
    Case CNum of
      0 :;
      1 : Begin { /notify  }
            DoListNotify(1);
          End;
      2 : Begin { /notify who }
            If PARSERFN(CCmd,2)='+' then
              begin
                DoListNotify(1);
                exit;
              end;
            If DoDelNotify( PARSERFN(CCmd, 2) ) then
              WlnWrite(CW, 'NOTIFY for user '+PARSERFN(CCmd,2)+' deleted');
          End;
    Else
          If DoInsNotify( PARSERFN(CCmd, 2), 0) then
          WlnWrite(CW, 'NOTIFY set for user '+PARSERFN(CCmd,2));
    End;
    exit;
   End;
 If CFirst = 'HB' then
   begin
     WlnWrite(CW, '*** Forcing Heartbeat');
     ForceHB := True;
     exit;
   end;

WlnWrite(CW,'*** Unknown Command: '+CFirst);

END;



BEGIN
  CCmd:='';  CCmdValid:=False;
  DoExit:=False;
  User.RegdIn:=False;
  init_spawno(GetEnv('TEMP'), swap_all,20,0)

END.

