{$M 16384, 0, $8192}

PROGRAM NFINGER;

Uses DOS,ABI,CRT,XSTRING,ABI_DOM;

{$I TCP.INC}

CONST   NulAddr: IPAddr = (0,0,0,0);

var Result: Integer;
    TmpAddr: IPAddr;
    TmpPort: Word;
    TmpLong: LongInt;
    Retry:Word;
    I : Integer;
    A : String;
    B : String;

Procedure ShowStatus(CurrentSession:tcpSessionREC);
 begin
     Write(StrHex(CurrentSession.Handle,2)+' ');
     Write('FROM:'+IPTOASCII(TcpDrvInfo.myip)+':');
     if CurSession.Tcp_srce=0 then Write('[',CurSession.LocalPort,']')
                               else Write(CurSession.Tcp_srce);
     Write('      =>  TO:  '+IPTOASCII(CurSession.IPDest)+':');
     Writeln(CurSession.Tcp_dest,'       ',tcpState[CurSession.Status.State]);

     Writeln('State         : ',CurSession.Status.State);
     Write('BytesReady    : ',CurSession.Status.BytesReady);
     Writeln('    BytesGoing    : ',CurSession.Status.BytesGoing);
     Write('Source IP     : ',IPTOASCII(CurSession.Status.ip_srce));
     Writeln('    Destination IP: ',IPTOASCII(CurSession.Status.ip_dest));
     Writeln(' IP Prot      : ',CurSession.Status.ip_prot);
     Writeln('  A C T I V E?: ',CurSession.Status.Active);
     Writeln;
 end;

Function Finger(userid:string; host:IPAddr; hoststring:string):Integer;
begin

  TmpPort:=FINGER_PORT;

  Write(IPTOASCII(TcpDrvInfo.myip)+':');
  Write(CurSession.LocalPort);
  Write(' attempting to connect to ',IPTOASCII(host));
  Writeln(':',TmpPort);
  Verbose:=True;
  Result:=Tcp_Open(CurSession,0,host,0,TmpPort,450);

  if Result=no_error then Writeln('Connection Established');

  Result:=Tcp_Status(CurSession,0);

  if Result=err_timeout then
    begin
      Writeln('No Response from '+IPTOASCII(CurSession.IPDest));
      halt(1);
    end;

  AddBuffer(CurSession.Buffer, 0, userid+#13+#10);

  Result:= tcp_Put(CurSession, 4, 500);

  If Result=0 then Writeln('Remote system is looking up user...',#34,userid,#34);

  Result:=Tcp_Status(CurSession,0);


  If CurSession.Status.Active=true then
   begin
     Retry:=0;
     repeat
          If KeyPressed then Key:=ReadKey  else Key:=#0;
          If Key='?' then
           begin
            ShowStatus(CurSession);
           end;
                                               {   PktsInputQueue:=Regs.AX; }
                                               {   PktsOutputQueue:=Regs.CX;}
          Result:=tcp_get(CurSession, 1, 0);

          If CurSession.Buffer.Length<>0 then
          begin
            for I:=1 to CurSession.Buffer.Length do
             begin
                if CurSession.Buffer.Buffer[I]=#10 then Write(#13);
                Write(CurSession.Buffer.Buffer[I]);
             end;
          end;
       If (Tcp_State(CurSession)=7) and (CurSession.Status.BytesReady=0) then
                Inc(Retry);
     until (Retry>250) or (CurSession.Result<>0) or (key=#27);
     ShowTcpError('[EOT]');
     {If CurSession.Result<>0 then Writeln(#13+#10+'[----END----]');}
     {ShowStatus(CurSession);}
   end;

 Result:=Tcp_Close(CurSession, 0, 350);
 Finger:=-1;
end;




BEGIN
 Writeln;
 Writeln('Turbo Pascal 7.0 - TCP/IP FINGER using Trumpet''s TCP/IP interface for DOS');
 Writeln;

 for I:=0 to 3 do TmpAddr[I]:=0;

 B:=ParamStr(1);
 if pos('@',B)<1 then
    begin
     Writeln('FINGER userid@server');
     Halt(3);
    end;

 A:=Copy(B, pos('@',B)+1, Length(B)-pos('@',B) );
 B:=Copy(B, 1, pos('@',B)-1);
 aton(A,TmpAddr);
 TmpLong:=0;
 Move(TmpAddr,TmpLong,4);
 If TmpLong=0 then
	 begin
		 Writeln('Resolving ',A);
     Verbose:=False;
     Result:=resolve(A, TmpAddr, 0);
			TmpLong:=0;
			Move(TmpAddr,TmpLong,4);
			If Result=0 then Writeln('DNS lookup failure?');
	 end;

 If TmpLong=0 then
	 begin
		Writeln;
		Writeln('Invalid Address was specified: '+#34,A,#34);
		Halt(2);
	 end;


 Result:=Finger(B,TmpAddr,A);
 If Result=0 then Writeln('Finger Ok');

END.

