
PROGRAM NNGETHDR;                           {NNTP Get Articles}

{$A+,B-,D+,E+,F-,G+,I+,L+,N-,O-,P-,Q-,R+,S+,T-,V+,X+}
{$M 16384,0,100000}


Uses DOS,ABI,CRT,XSTRING,ABI_DOM,ABI_JP,STRINGS;

{$I TCP.INC}

var
    ArtEstimate:LongInt;
    ArtFirst:LongInt;
    ArtLast :LongInt;
    ArtGroup:String;
    ArtLines:LongInt; {Lines: }
    ArtLine:LongInt;  {current}
    ArtNum:LongInt;
    ArtCount:Word;
    Result: Integer;
    TmpAddr: IPAddr;
    TmpPort: Word;
    TmpLong: LongInt;
    HighestRetrieved : LongInt;
    TmpStr:String;
    I : Integer;
    A : String;
    B : String;

Procedure CrashNBurn(ToShow:String);
 begin
  Writeln(ToShow);
  Result:=Tcp_Close(CurSession, 0, 150);
  Halt(10);
 end;

Function BWStr(var TmpNum:word; Len:Byte):String;
 var
  TmpStr:String;
 begin
    case Len of
      0: Str(TmpNum,TmpStr);
      1: Str(TmpNum:1,TmpStr);
      2: Str(TmpNum:2,TmpStr);
      3: Str(TmpNum:3,TmpStr);
      4: Str(TmpNum:4,TmpStr);
      5: Str(TmpNum:5,TmpStr);
      6: Str(TmpNum:6,TmpStr);
      7: Str(TmpNum:7,TmpStr);
     else
        Str(TmpNum,TmpStr);
    end;
  BWStr:=TmpStr;
 end;

Function BLStr(var TmpNum:LongInt; Len:Byte):String;
 var
  TmpStr:String;
 begin
    case Len of
      0: Str(TmpNum,TmpStr);
      1: Str(TmpNum:1,TmpStr);
      2: Str(TmpNum:2,TmpStr);
      3: Str(TmpNum:3,TmpStr);
      4: Str(TmpNum:4,TmpStr);
      5: Str(TmpNum:5,TmpStr);
      6: Str(TmpNum:6,TmpStr);
      7: Str(TmpNum:7,TmpStr);
     else
        Str(TmpNum,TmpStr);
    end;
  BLStr:=TmpStr;
 end;


  (* Number of substrings in a string *)
  function PARSENFN (sj : string) : integer;
  var i, n, p : integer;
  begin
    p := Length(sj);
    n := 0;
    i := 1;
    repeat
      while (sj[i] <= #32) and (i <= p) do Inc(i);
      if i > p then begin parsenfn := n; exit; end;
      while (sj[i] > #32) and (i <= p) do Inc(i);
      Inc(n);
      if i > p then begin parsenfn := n; exit; end;
    until false;
  end;  (* parsenfn *)
  {}
  (* Get substrings from a string *)
  function PARSERFN (sj : string; PartNumber : integer) : string;
  var i, j, n, p : integer;
      stash      : string;
  begin
    if (PartNumber < 1) or (PartNumber > PARSENFN(sj)) then
      begin PARSERFN := ''; exit; end;
    p := Length(sj);
    n := 0;
    i := 1;
    repeat
      while (sj[i] <= #32) and (i <= p) do Inc(i);
      Inc(n);
      if n = PartNumber then
        begin
          j := 0;
          while (sj[i] > #32) and (i <= p) do
            begin
              Inc(j);
              stash[0] := chr(j);
              stash[j] := sj[i];
              Inc(i);
            end;
          PARSERFN := stash;
          exit;
        end
       else
         while (sj[i] > #32) and (i <= p) do Inc(i);
    until false;
  end;  (* parserfn *)

Function SelectNewsGroup(newsgroup: string):Boolean;
 var
   TmpRes:Boolean;
   tW:Word;
   Result:Integer;
   TmpStr:String;
   ArtTmp:String;
 begin
   SelectNewsGroup:=False;
   TmpRes:=False;
      Writeln('Sending Group Message: ',newsgroup);
      tcp_sendtextln(CurSession, 'GROUP '+newsgroup);
      If CurSession.Result<>0 then Writeln('Send: ',Result);

      Write(#34);
      ShowBuffer(CurSession.Buffer, 1);
      Writeln(#34);
      Result:=tcp_get(CurSession, 2, 1000);
      If Result<>0 then
        begin
         Writeln('Timeout on Reply for GROUP');
         exit;
        end;

      Write(#34);
      TmpStr:=ShowBuffer(CurSession.Buffer, 3);
      Writeln(#34);

      If (Msg.Pro='4') AND (Msg.Cat='1') then
        begin
          Writeln('*NO SUCH NEWS GROUP*');
          exit;
        end;
      If (Msg.Pro='2') AND (Msg.Cat='1') then
        begin
          If PARSENFN(TmpStr)<5 then Writeln('*REPLY DOES NOT GIVE DETAILS*');
          ArtTmp:=PARSERFN(TmpStr, 2);
          Val(ArtTmp,ArtEstimate,Result);

          ArtTmp:=PARSERFN(TmpStr, 3);
          Val(ArtTmp,ArtFirst,Result);

          ArtTmp:=PARSERFN(TmpStr, 4);
          Val(ArtTmp,ArtLast,Result);

          ArtGroup:=PARSERFN(TmpStr, 5);
          Writeln('*** Confirmed Selection of Group: ',#34,ArtGroup,#34);
          Writeln;
          Writeln(' There is approximately ',ArtEstimate,' message(s) in this newsgroup.');
          Writeln(' The numbers of the messages range from ',ArtFirst,' to ',ArtLast,'.');


          TmpRes:=True;
          SelectNewsGroup:=TmpRes;
          exit;
        end;
     Writeln('Unknown Error With GROUP');
   SelectNewsGroup:=TmpRes;
 end;

Function Getlisting(listingfile:string):Boolean;
CONST SLEN = 2048;
TYPE linetype = array[0..SLEN] of Char;
     FileBufferType = Array[0..4096] of Char;
 var
  line : ^linetype;
  TmpBuffer : ^BufferRec;
  validline : Boolean;
  TmpRes:Boolean;
  TmpLong:LongInt;
  output:text;
  OutputFileName:String;
  Result:Integer;
  TmpStr:string;
  ArtStr:string;
  LastStr:String;
  Retries:Integer;
 begin
  TmpRes:=False;
  GetListing:=False;

  OutputFileName:=listingfile; {LISTING.NEW}

  tcp_sendtextln(CurSession, 'XHDR Subject '+BLStr(ArtFirst,0)+'-'+BLStr(ArtLast,0));
  If CurSession.Result<>0 then Writeln('Send: ',Result);

  Result:=tcp_get(CurSession, 2, 750);
  If Result<>0 then
    begin
     Writeln('Timeout on 1st line Reply for XHDR');
     exit;
    end;
  Write(#34);
  TmpStr:=ShowBuffer(CurSession.Buffer, 1);
  Writeln(#34);
  Writeln('Recieving');
  ArtLines:=0;
  ArtLine:=0;

  New(line);
  New(TmpBuffer);
  Assign(output,OutputFileName);
  ReWrite(output);
   Retries:=0;
  Repeat
   repeat
    LastStr:= StrPas(line^);
      line^[0] := #0;
      If CurSession.DAT.ReadCRLF then
        begin
          TmpBuffer^.Length := 0;
          TmpStr := '';
        end;
      validline := False;
      CurSession.DAT.ReadCRLF := false;
      Result := tcp_get(CurSession, 3, 0);
      If CurSession.Buffer.Length >
         (SizeOf(TmpBuffer^.Buffer)-TmpBuffer^.Length+1) then
        begin
          asm nop end;
          Write('ERROR: BUFFER OVERFLOW!');
          Delay(100);
          asm nop end;
        end else
        begin
          Move(CurSession.Buffer.Buffer, TmpBuffer^.Buffer[TmpBuffer^.Length +1 ],
               CurSession.Buffer.Length);
          TmpBuffer^.Length := TmpBuffer^.Length + CurSession.Buffer.Length;
          CurSession.Buffer.Length := 0;
        end;
{      TmpDis := '['+tcpState[CurSession.Status.State]+']'; }
      {ShowStatusBar('');}
   until CurSession.DAT.ReadCRLF or (CurSession.Result<>0);
    TmpStr := ShowBuffer(TmpBuffer^, 6);
    Move(TmpBuffer^.Buffer, line^, SizeOf(line^));
    line^[TmpBuffer^.Length] := #0;
    line^[TmpBuffer^.Length+1] := #0;

     If (CurSession.DAT.ReadCRLF) AND (CurSession.Result=0) then
       begin
         validline := true;
         TmpStr := ShowBuffer(TmpBuffer^, 3);
         If ArtLine<>0 then Inc(ArtLine);
         If (ArtLine=0) and (TmpStr='') then Inc(ArtLine);
{         If (TmpStr<>'.') then Writeln( }
         Writeln(output, line^);
{         Writeln(line^); }
         Writeln;
       end;
      If Result=5 then Result:=0;
      Result:=tcp_Status(CurSession,0);
   Until ((TmpStr='.') and (CurSession.DAT.ReadCRLF)) or (KeyPressed);
      If (Result=0) and (TmpStr='.') then
        begin
          GetListing:=True;
        end;
      If (Result<>0) then
        begin
           Writeln('Error on reply of XHDR: ',Result);
           Writeln(output, '[ERROR WITH XHDR]');
       end;
        If (KeyPressed) then
           begin
            Writeln(' Aborted XHDR');
            Writeln(output, '[XHDR_ABORTED]');
            GetListing:=False;
           end;
  Dispose(TmpBuffer);
  Dispose(line);
  Close(Output);
 end;

Function MainNNTPGetHdr(newsgroup:string; artlistfile:string; host:IPAddr; hoststring:string):Integer;
var
  ArtList:text;
  TmpStr:String;
  ArtInfo:String;
  Result:Integer;
  tmpBoolean:Boolean;
begin
  MainNNTPGetHdr:=-1;
  TmpPort:=NNTP_PORT;

  Result:=Tcp_Open(CurSession,0,host,0,TmpPort,450);
  if Result=no_error then Writeln('Connection Established');
  If Result=err_nohandles then CrashNBurn('No Handles on Open');
  If Result=err_badsession then CrashNBurn('Bad Session on Open');

  if Result=err_timeout then
    begin
      Writeln('No Response from '+IPTOASCII(CurSession.IPDest));
      MainNNTPGetHdr:=-5;
      exit;
    end;
  Result:=Tcp_Status(CurSession,0);

  Result:=tcp_get(CurSession, 2, 1550);
  If Result=err_timeout then
    begin
      Writeln('No Response from NNTP Server');
      MainNNTPGetHdr:=-1;
      exit;
    end;
  If Result<>0 then
    begin
      Writeln('Error on NNTP negotiation (first receive)');
      If Result = err_badhandle then Writeln('Bad Handle with tcp_get');
      MainNNTPGetHdr:=-1;
      exit;
    end;

  Result:=Tcp_Status(CurSession,0);

  Write(#34);
  TmpStr:=ShowBuffer(CurSession.Buffer, 1);
  Writeln(#34);


 If SelectNewsGroup(newsgroup) then
   begin
      TmpBoolean:=GetListing(artlistfile);
      If TmpBoolean then Writeln('OK[XHDR]')
                    else Writeln('Retrieve attempt aborted');

      Writeln('[Sending Quit]');
      tcp_sendtextln(CurSession, 'QUIT');
      Result:=tcp_get(CurSession, 2, 750);
       If Result<>0 then
         begin
          Writeln('Timeout on Reply for QUIT');
          exit;
         end;
       Write(#34);  ShowBuffer(CurSession.Buffer, 3);  Write(#34);

   end;

 ShowTcpError('[EOT]');
 Result:=Tcp_Close(CurSession, 0, 350);
 MainNNTPGetHdr:=0;
end;




BEGIN
 Writeln;
 Writeln('Turbo Pascal 7.0 - NNTPGetHdr for DOS');
 Writeln;

 TmpAddr:=NullAddr;

 if ParamCount<3 then
    begin
     Writeln('NNTPGetHdr <group> <nntp-art-list> <server>');
     Halt(3);
    end;

 A:=ParamStr(3);
 B:=ParamStr(2);
 aton(A,TmpAddr);
 TmpLong:=0;
 Move(TmpAddr,TmpLong,4);
 If TmpLong=0 then
   begin
    Writeln('Resolving ',A);
    Result:=resolve(A, TmpAddr, 0);
    TmpLong:=0;
    Move(TmpAddr,TmpLong,4);
    If Result=0 then Writeln('DNS lookup failure');
   end;

if TmpLong=0 then
   begin
    Writeln;
    Writeln('Invalid Address was specified: '+#34,A,#34);
    Halt(2);
   end;
 NormVideo;
 Window(1,2,80,25);
 ClrScr;
 Result:=MainNNTPGetHdr(ParamStr(1), ParamStr(2), TmpAddr, A);
 ShowTcpError('[EOP]');
 Writeln;
 If Result=0 then Writeln('Article Retreival Completed');

END.

