(******************************************************************
  event_call, upcall:  ax   = event-id (ax = same as int call)
                       bx   = handle (FFFF if general failure)
                       cx:dx= info   (e.g. no of bytes transferred)

              return:  registers not preserved







******************************************************************)

(********** Compiling Options **************)


{$UNDEF  SHOWSTARTMSG}
{$UNDEF  CXINT}        {This continues with interrupts when processing
                        TCPDRV.EXE  (requires DOIO_TIMER) to be defined}
{$UNDEF  DOIO_TIMER}
{$DEFINE TCPDRV301}
{$DEFINE DOQUIETEXEC}

(*************************)
CONST
   AutoLoadNTCPDRV : Boolean = True;
   StartUpMsgLen = 131;
   StartUpMsg : Array[1..StartUpMsgLen] of Char =
   'TCP/IP for Turbo Pascal 7.0 using Trumpet''s TCP/IP interface for DOS'+  {68}
 #13+#10+'Version 1.00a by Jeff Patterson (aka Gamer)  (c) Dec 1996'+#13+#10;

(*************************)
CONST  {tcp / tcpabi}
   tcpState : Array[0..12] of String[12] = ('ERROR','LISTEN','SYN-SENT','SYN-RCVD',
                       'ESTABLISHED','FIN-WAIT1','FIN-WAIT2','CLOSE-WAIT',
                       'CLOSING','LAST-ACK','TIME-WAIT','CLOSED','TOO_HIGH');
                              {above may not be entirely correct}
   no_error       = 0;
	 err_badcall		= 1;
	 err_critical 	= 2;
	 err_nohandles	= 3;
	 err_badhandle	= 4;
	 err_timeout		= 5;
	 err_badsession = 6;

   tcpMaxSessions = 8;    {NTCPDRV's default?  0 to 8? }

CONST    {--- Services ---}
     ECHO_PORT        : Word = 7;   {udp & tcp}
     DISCARD_PORT     : Word = 9;   {udp & tcp}   {sink null}
     SYSTAT_PORT      : Word = 11;  {tcp}         {users}
     QOTD_PORT        : WORD = 17;  {tcp?/udp}         {quote}
     COOKIE_PORT      : WORD = 17;  {udp?}
     FTP_PORT         : Word = 21;
     TELNET_PORT      : Word = 23;
     SMTP_PORT        : Word = 25;
     NAMESERVER_PORT  : Word = 42;  {tcp}
     DOMAIN_PORT      : Word = 53;  {udp & tcp}   {nameserver}
     FINGER_PORT      : Word = 79;
     HTTP_PORT        : Word = 80;  {tcp}
     LINK_PORT        : Word = 87;  {tcp}         {ttylink}
     POP3_PORT        : Word = 110; {tcp}         {postoffice}
     AUTH_PORT        : Word = 113; {tcp}         {authentication}
     NNTP_PORT        : Word = 119; {tcp}
     IRC_X_PORT       : Word = 194; {udp & tcp}

     {Other common ports}
     OTHER_PORT       : Word = 1234;
     OTHERH_PORT      : Word = $1234;
     TERM_PORT        : Word = 5000; {tcp}       {default for KA9Q term server}
     IRC_PORT         : Word = 6667; {tcp}

     {Useful Unix Specifics}
     NETWALL_PORT     : Word = 533; {udp}        {-for emergency broadcasts}

