
{$DEFINE USEHEAP}

Unit JPIEXCMD;        {    JPIRC EXtra CoMmanDs  }

Interface

Uses ABI, ABI_DOM, ABI_JP, JP_UNIT, JPIRCVAR, JPIRCWIN, XSTRING;   { , JPI_ICMP;}

var   OGS        : ^tcpSessionREC;    { OutGoing Session }
      IEX_Status : String[160];
      IEX_More   : String[127];   {Filename}
      IEX_Finger : String[80];

Procedure ProcessIEX;
Procedure ProcessIEX_CMD(CLine:String);

Implementation

var   SaveExitProc : Pointer;
      Result       : Word;
      FingerState  : Byte;
      FingerBuffer : ^BufferREC;
      MoreState    : Byte;
      MoreFile     : text;
      MoreLine     : Word;
      TmpStr       : String;


Procedure ProcessIEX_CMD(CLine:String);
var CNum : Word;
    CFirst,CSecond : String[80];
    A : String;
    Result:Integer;
BEGIN
  Delete(CLine,1,1);
  CNum   := PARSENFN(CLine);
If (CNum=0) or (Length(CLine)=0) then exit;
  CFirst := UCase(PARSERFN(CLine, 1));
  CSecond := UCase(PARSERFN(CLine, 2));

If (CFirst='ST') or (CFirst='STATUS') then
  begin
   WlnWrite(CW, ' FINGER (OGS^) handle= '+StrHex(OGS^.Handle,4));
{   WlnWrite(CW, ' IP ICMP       handle= '+StrHex(ISESX^.Handle,4)); }
   exit;
  end;
If (CFirst='MORE') and (MoreState>0) then MoreState:=3;
If (CFirst='FINGER') and (FingerState>0) then FingerState:=5;
If (CFirst='FINGER') and (FingerState=0) then IEX_Finger:=PARSERFN(CLine,2);
If (CFirst='MORE') and (MoreState=0) then
  begin
     IEX_More:=CSecond;
  end;
{If (CFirst='GO') and (FingerState=3) then FingerState:=1;}
If (CFirst='GO') and (MoreState=2) then MoreState:=1;
If (CFirst='STOP') then
  Begin
    If FingerState>0 then FingerState:=5;
    If MoreState>0 then MoreState:=3;
  End;

END;

Procedure Process_Finger;
var A, B, C:String;
    TmpIP:IPAddr;
    W:Word;
    Result:Integer;
Begin
 If (IEX_Finger='') then
     begin
       FingerState:=0;
       exit;
     end;
 If OGS^.Openned then Result:=Tcp_Status(OGS^,0);
 Case FingerState of
   0 : Begin
        B:=IEX_Finger;
        If Pos('@',B)<1 then
            begin
             WlnWrite(CW, 'USAGE:  /FINGER [<userid>]@<host> [<port>]');
             FingerState:=0;
             IEX_Finger:='';
            end;
        A:=Copy(B, Pos('@',B)+1,  Length(B)-Pos('@',B) );
        C:=Copy(B, Length(B)-Pos('@',B), 5);
        B:=Copy(B, 1, Pos('@',B)-1);
        If not ip_lookup(A, TmpIP) then
          begin
            WlnWrite(CW, 'Unknown Host: '+A);
            IEX_Finger:='';
            exit;
          end;
        FingerBuffer^.Length:=0;
        Val(C, W, Result);
        If Result <> 0 then W:=79;
        Result:=tcp_open(OGS^, 0, TmpIP, 0, W, TcpOpenTime);
        If Result=no_error then WlnWrite(CW, 'FINGER** Connection Established');
        If Result<>no_error then
          begin
            IEX_Finger:='';
            FingerState:=0;
            exit;
          end;
        AddBuffer(OGS^.Buffer, 0, B);
        FingerState:=1;
       End;
   1 : Begin
        If (Tcp_State(OGS^)=7) then
          begin
           FingerState:=5;
           exit;
          end;
        If (Tcp_State(OGS^)<>4) then
          begin
           FingerState:=1;
           exit;
          end;
        Result := tcp_put(OGS^, 6, 300);
        FingerState:=2;
       End;
   2 : Begin
        If ReadlnBuff(OGS^, FingerBuffer^) then FingerState:=3;
        W:=tcp_State(OGS^);
        If IsScrLock then WlnWrite(CW, 'OGS = '+tcpState[W]);
        If (W=7) and (OGS^.Status.BytesReady=0) and (FingerBuffer^.Length=0) then
            begin
              FingerState:=5;
              exit;
            end;
       End;
   3 : Begin
        WlnAWrite(CW, FingerBuffer^);
        FingerBuffer^.Length:=0;
        FingerState:=2;
       End;
   5 : Begin
         If OGS^.Openned then Result:=tcp_Close(OGS^, 0, 150);
         WlnWrite(CW, 'FINGER** Session Done');
         IEX_Finger:='';
         OGS^.Buffer.Length:=0;
         FingerState:=0;
       End;
  End;
{ If (Tcp_State(OGS^)=7) and (OGS^.Buffer.Length=0) then FingerState:=5; }
{ If (Tcp_State(OGS^)=1) and (OGS^.Buffer.Length=0) then FingerState:=0; }

End;

Procedure Process_MoreFile;
var  FM:Byte;
Begin
If IEX_More='' then
    begin
     MoreState:=0;
     exit;
    end;
Case MoreState of
 0: Begin
      FM:=FileMode;
      MoreLine:=0;
        Assign(MoreFile, IEX_More);
{$I-}
        Reset(MoreFile);
        MoreState:=1;
        If IOResult<>0 then
          Begin
            WlnWrite(CW, '/// File '+IEX_More+' Not found');
{            Close(MoreFile); }
            MoreState:=0;
            IEX_More:='';
            exit;
          End;
{$I+}
      FileMode:=FM;
      If MoreState=1 then WlnWrite(CW, '\\\ File '+IEX_More+' Openned');
    End;
 1: Begin
      If not EOF(MoreFile) then
        Begin
         Readln(MoreFile, TmpStr);
         WlnWrite(CW, TmpStr);
         Inc(MoreLine);
         If MoreLine>20 then
                Begin
                  MoreState:=2;
                  WlnWrite(CW, '____/PAUSED\____');
                End;
       End Else Begin
         MoreState:=3;
        End;
    End;
 2: Begin
      MoreLine:=0;
    End;
 3: Begin
      Close(MoreFile);
      WlnWrite(CW, '/// File Closed');
      MoreState:=0;
      IEX_More:='';
    End;
  End;
End;



Procedure ProcessIEX;
var tResult:Integer;
    A,B,C : String;
    tSPort, tCPort : Word;
Begin

Process_MoreFile;
Process_Finger;

If (FingerState=0) and (OGS^.Openned) then
  begin
   Result:=tcp_Close(OGS^, 0, 100);
   WlnWrite(CW, '<<< Weird  IEX CMD FINGER bug found');
  end;

If IEX_More='' then StatLine[69]:=' '  else StatLine[69]:='O';

End;


Procedure InitIEX;
Begin
 MoreState:=0;    IEX_More:='';
 FingerState:=0;  IEX_Finger:='';
 Assign(MoreFile, '');
End;


{$F+}
Procedure IEX_NewExitProc; far;
 begin
   ExitProc:=SaveExitProc;
   If OGS^.Openned then Result:=tcp_Close(OGS^, 0, 100);
   Dispose(OGS);
   Dispose(FingerBuffer);
   If MoreState>0 then Close(MoreFile);
 end;


BEGIN
 New(FingerBuffer);
 New(OGS);
 FillChar(OGS^, SizeOf(OGS^), #0);
 SaveExitProc:=ExitProc;
 ExitProc:=@IEX_NewExitProc;
 InitIEX;

END.    (C) 1997 - Copyright ParSoft, by Jeff Patterson

