{$UNDEF  DEBUGLOG}
{$DEFINE USEHEAP}
{$DEFINE USEIDENTD}
{$DEFINE USEHB}
{        OVERLAY}
{$UNDEF OURICMP}
{        DEBUG}
{$DEFINE VERICFG}

{$IFNDEF DEBUG}
{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S+,T+,V+,X+}
{$ELSE}
{$A+,B-,D+,E-,F-,G+,I+,L+,N-,O-,P-,Q-,R+,S+,T+,V+,X+}
{$ENDIF}

{$IFDEF USEHEAP}
 {$M $5000,22000,76000}      {16384,60000}
{$ELSE}
 {$M $5000,$2000,$4000}
{$ENDIF}

PROGRAM JPIRC;



Uses Crt, DOS,ABI, XSTRING, JP_UNIT, ABI_JP, ABI_DOM,
{$IFDEF OURICMP}
     JPI_ICMP,
{$ENDIF}
{$IFDEF USEIDENTD}
     IDENTD,
{$ENDIF}
     JPIRCVAR, JPIRC_IO,
{$IFDEF USEHB}
      JPIRC_HB,
{$ENDIF}
{$IFDEF OVERLAY}
     OVERLAY,
{$ENDIF}
     JPIRCCMD, JPIRCWIN, JPIRC_IN,
     JPIEXCMD, JPIRCDCC;

{$IFDEF OVERLAY}
{$O JPIRCHLP}  {$O JPIRCCMD}  {$O JPIRCSET}  {$O ENCRYPT}
{$ENDIF}

var TmpStr:String;
    LastIsConnected :Boolean;
    I : Integer;
    TmpIP:IPAddr;
    TmpB:Boolean;
    TmpByte:Byte;
    TmpSeg, TmpOff, ToDisLength, wCount : Word;
    TmpHex:String;
    Debugfile: text;
    JPIRCSaveExitProc : Pointer;


Procedure ShowCookie;
var QOTDS : ^udpSessionREC;
    QOTDIP : IPAddr;
Begin
 If QOTDServer ='' then exit;
 If not ip_lookup(QOTDServer, QOTDIP ) then exit;

 New(QOTDS);
 Result := udp_Open(QOTDS^, 0, QOTDIP, 0, QOTD_PORT);
 If Not (Result=0) then
   begin
     WlnWrite(CW, 'Unable to send UDP packet to QOTD server');
     Dispose(QOTDS);
     exit;
   end;
 AddBuffer( QOTDS^.Buffer, 0, #13 );
 Result := udp_Send( QOTDS^, 0, $0D17, 0, 0, 250);
 If Result<>0 then
   begin
     Result:= udp_close(QOTDS^, 0);
     Dispose(QOTDS);
     exit;
   end;
  Result := udp_Recv( QOTDS^, 0, 350);
  If (Result>0) and (Result<>err_timeout) then WlnWrite(CW,'-error-');
  Result := udp_Close(QOTDS^, 0);
  If QOTDS^.Buffer.Length>0 then
    begin
      WlnAWrite(CW, QOTDS^.Buffer);
    end;
  Dispose(QOTDS);

End;


{$F+}
 Procedure DCFWaiting; far;
   var
     tX, tY:Word;
   begin
     TrumpetBusy := True;
     ShowStatusLine(CW,'');
     TrumpetBusy := False;
   end;
{$F-}
{$F+}
   Procedure JPIRC_NewExitProc;
   Begin
     ExitProc:=JPIRCSaveExitProc;
    asm nop end;
   End;
{$F-}

BEGIN
   Verbose:=False;
{$IFNDEF DEBUG}
   CheckBreak:=False;
   SetCBreak(False);
   DebugLogFlag:=False;
{$ELSE}
   DebugLogFlag := True;
   CheckBreak := True;
   SetCBreak(True);
{$ENDIF}
   DirectVideo:=True;
   LastIsConnected := False;
(*****
   JPIRCSaveExitProc := ExitProc;
   ExitProc:=@JPIRC_NewExitProc;
*****)
   DCFWaitingProc := DCFWaiting;

{$IFDEF USEIDENTD}
If BeStrictD then IDENTDUserName^:=User.UserName;
Verbose := False;
ABI.Verbose := False;
If User.HostName = '!' then
  Begin
    WlnWrite(CW, 'Resolving hostname that matches your IP ('+IPTOASCII(TcpDrvInfo.myip)+')...');
    Move(TcpDrvInfo.myip, TmpIP, 4);
    TmpStr :=IPTOASCII(TmpIP);
    Result:= Resolve(TmpStr, TmpIP, 0);
    User.HostName := TmpStr;
    If result=0 then User.HostName := '*'
                else WlnWrite(CW, 'Hostname found as "'+TmpStr+'"');
    If result=0 then User.HostName := '*';
  End;
If User.HostName = '*' then
  Begin
    User.HostName := IPTOASCII(TcpDrvInfo.myip);
  End;
{$ENDIF}

   Window(1,1,80,23);

   Window(1,1,80,25);
   VERBOSE:=TRUE;
{  ShowCookie; }
   VERBOSE:=FALSE;

If uCase(ParamStr(1))='BOBCAT' then
  begin
    DefaultServer := ParamStr(2);  User.ServerName := ParamStr(2);
    Val(ParamStr(3), DefaultPort, Result);
    If (Result<>0) or (DefaultPort=0) then DefaultPort:=6667;
    User.ServerPort := DefaultPort;
    WlnWrite(CW,'*** BOBCAT Startup: '+ParamStr(4));
    WlnWrite(CW,'*** IRC Server='#34+ParamStr(2)+#34);
    WlnWrite(CW,'*** IRC Port  ='#34+ParamStr(3)+#34);
    If DefaultServer<>'' then AutoRegister := True;
    ExitFirstQuit := True;
    BeStrictD := False;  { for now since URL's probably won't match SERVERS.IRC}
    If Length(OurVersion) <100-25 then OurVersion := OurVersion +' under Bobcat WWW browser';
  end;

If uCase(ParamStr(1))='-FILE' then
  begin
    Assign(tf, ParamStr(2));
{$I-}
    Reset(tf);
{$I+}
    If IOResult=0 then
      begin
        CIN_prefix := '';
        while not eof(tf) do
         begin
           Readln(tf, TmpStr);
           TmpHex := uCase(PARSERFN(TmpStr,1));
           If (TmpHex='TITLE') then
             begin
               WlnWrite(CW,'*FileStartup* '+PARSERREST(TmpStr,2));
             end else
           If (TmpHex='SERVER') then
             begin
               DefaultServer := PARSERREST(TmpStr, 2);
               User.ServerName := DefaultServer;
             end else
           If (TmpHex='PORT') then
             begin
               Val(PARSERFN(TmpStr,2), DefaultPort, Result);
               If (Result<>0) or (DefaultPort<100) then DefaultPort :=6667;
               User.ServerPort := DefaultPort;
             end else
           If (TmpHex='CHANNEL') then
             begin
               asm nop end;
               CIN_prefix := PARSERREST(TmpStr,2);
             end;
         end;
        Close(tf);
        WlnWrite(CW,'*** IRC Server='#34+DefaultServer+#34);
        WlnWrite(CW,'*** IRC Port  ='#34+LeadingZero(DefaultPort,4)+#34);
        if CIN_prefix<>'' then WlnWrite(CW,'*** CHANNEL (Auto-unimplemented) = '#34+CIN_prefix+#34);
        If DefaultServer<>'' then AutoRegister := True;
        ExitFirstQuit := True;
        BeStrictD := False;  { for now since URL's probably won't match SERVERS.IRC}
        If Length(OurVersion) <100-25 then OurVersion := OurVersion +' w/ start-file';
      end else Halt(2);
  end;




{$IFDEF VERICFG}
  If (IPTOASCII(TcpDrvInfo.myip)='0.0.0.0') or
     (IPTOASCII(TcpDrvInfo.netmask)='0.0.0.0') or
     (IPTOASCII(TcpDrvInfo.netmask)='255.255.255.255') or
     (IPTOASCII(TcpDrvInfo.gateway)='0.0.0.0') then
    begin
      WlnWrite(CW,'!!! '^_'NTCPDRV.EXE is not configured correctly'^_'.');
      WlnWrite(CW,'!!! IP='+IPTOASCII(TcpDrvInfo.myip));
      WlnWrite(CW,'!!! GATEWAY='+IPTOASCII(TcpDrvInfo.gateway));
      WlnWrite(CW,'!!! NETMASK='+IPTOASCII(TcpDrvInfo.netmask));
      WlnWrite(CW,'!!! DNS='+IPTOASCII(TcpDrvInfo.dnsserver));
      WlnWrite(CW,'!!! The IP address, Gateway, and Netmask cannot be 0.0.0.0');
      WlnWrite(CW,'!!! See jpIRC documentation for more information.');
    end;
{$ENDIF}

If AutoRegister then OpenAndRegister;
   Assign(DebugLog,'DEBUGIRC.LOG');
   ReWrite(DebugLog);
{$IFDEF DEBUGLOG}
   Assign(Debugfile,'debug.hex');
   ReWrite(Debugfile);
{$ENDIF}

  WlnWrite(CW,'*** '^B+ClientVer+^B' (internal version '^_+ClientDate+^_')');
  WlnWrite(CW,'***');
  WlnWrite(CW,'*** Written by '+ClientAuthor);

  WlnWrite(CW,'   ');
  WlnWrite(CW,'*!* '^B'This is a '^V'TEST'^V' version of jpIRC.EXE - use with caution');
If AutoLoadNTCPDRV then
     WlnWrite(CW, '*!* This version contains experimental auto-ntcpdrv.exe load routines');
  WlnWrite(CW,'   ');

  WlnWrite(CW,'***');
{$IFDEF USEHB}
     ForceHB := True;
     JPIRC_HeartBeat;
{$ENDIF}
  WlnWrite(CW,'*** Ready.');
{  AbsGotoXY( WindowA^[CW].CX,WindowA^[CW].CY); }
  AbsGotoXY( 5, WindowA^[CW].CY+1);
   Repeat
     Online:=tcp_IsConnected(IRCS);

     If Online then
       begin
         Result:=tcp_status(IRCS, 0);
{         If (Result>0) and (IRCS.Handle>0) then Result:=tcp_close(IRCS,0,200); }
       end;
     If Not Online then
       begin
        If LastIsConnected = True then
          begin
            WlnWrite(CW, '+++ Connection with '+User.Servername+' disconnected');
          end;
        IRCS.Buffer.Length:=0;
        CIN_Buff.Length:=0;
        CIN_Line:='';
        If IRCS.Openned then  Result:=tcp_close(IRCS, 0, 250);
        IRCS.Buffer.Length:=0;
       end;
     TmpStr:='';
{$IFDEF USEHB}
     JPIRC_HeartBeat;
{$ENDIF}
     For I:=1 to MaxWindows do
        begin
          If WindowA^[I].SY1<>0 then ShowStatusLine(I, '');
        end;
     ProcessConsoleIO;
     JP_Idle;
     ProcessConsoleCMD;
     JP_Idle;
{$IFDEF USEIDENTD}
     ProcessTcpIDENTD;
{$ENDIF}
{$IFDEF OURICMP}
     Process_ICMP;
{$ENDIF}
     JP_Idle;
     Online:=tcp_IsConnected(IRCS);
     ProcessIncomingIO;
     ProcessAllDCC_Channels;
If DebugLogFlag then
  BEGIN
     If Length(CIN_Line)>0 then Writeln(DebugLog,CIN_Line);
     If (Length(CIN_prefix)>0) and (Length(CIN_Line)>0) then
         begin
            If CIN_prefix<>'' then Writeln(DebugLog, 'PrefixWas: ',CIN_prefix);
            If CIN_PAddr<>'' then Writeln(DebugLog, 'CIN_PAddr: ',CIN_PAddr);
            If CIN_PNick<>'' then Writeln(DebugLog, 'CIN_PNick: ',CIN_PNick);
            If CIN_PUser<>'' then Writeln(DebugLog, 'CIN_PUser: ',CIN_PUser);
            If CIN_PHost<>'' then Writeln(DebugLog, 'CIN_PHost: ',CIN_PHost);
            Writeln(DebugLog, '--------------------------------------------');
         end;

{$IFDEF DEBUGLOG}
     If (CIN_Buff.Length>0) and (CIN_Valid) then
        begin
            TmpSeg:=Seg(CIN_Buff.Buffer);
            TmpOff:=Ofs(CIN_Buff.Buffer);
            ToDisLength:=CIN_Buff.Length;
            wCount:=0;
             TmpStr:='';
             TmpHex:='';
            repeat
             if ((wCount/8)=Trunc(wCount/8)) then Write(Debugfile,' ');
             if ((wCount/16)=Trunc(wCount/16)) then
               begin
                Writeln(Debugfile, ' '+TmpStr); TmpStr:=''; TmpHex:='';
                Write(Debugfile, WordToHexASCII(wCount),': ');
               end;
             TmpByte:=Mem[TmpSeg:TmpOff+wCount];
             Write(Debugfile, ByteToHexASCII(TmpByte)+' ');
             TmpStr:=TmpStr+Chr(CleanChr[TmpByte]);
            inc(wCount);
            until wCount=ToDisLength;
             Writeln(debugfile, ' '+TmpStr);
        end;
{$ENDIF}

  END;

   Online:=tcp_IsConnected(IRCS);
   LastIsConnected := OnLine;
   ProcessIncomingMSG;

   ProcessIEX;
   Until DoExit;

   Close(DebugLog);
{$IFDEF DEBUGLOG}
   Close(Debugfile);
{$ENDIF}
    If IRCS.Openned then
     begin
      If Online or tcp_IsConnected(IRCS) {or Tcp_Active(IRCS)} then
           begin
            If User.RegdIn then tcp_sendtextln( IRCS, 'QUIT :'+TmpStr);
           end;
      Result:=tcp_close(IRCS, 0, 250);
     end;
    Verbose:=False;
    NormalExit:=True;

 {  InitDisplay; }
END.

