{$IFDEF OVERLAY}
{$O+}
{$ENDIF}
Unit JPIRCHLP;


Interface

Uses JP_UNIT,
     JPIRCVAR, JPIRCWIN, XSTRING;

Procedure ProcessHelpLine(CLine:String);

Implementation

var   SaveExitProc : Pointer;
      Result       : Word;
      TmpStr       : String;


Procedure ProcessHelpLine(CLine:String);
var CNum : Word;
    CFirst,CSecond : String[40];
    A : String;
    Result:Integer;
BEGIN
  CNum   := PARSENFN(CLine);
  If CNum>0 then CFirst := Copy(UCase(PARSERFN(CLine, 1)),1,40);
  If CNum>1 then CSecond := Copy(UCase(PARSERFN(CLine, 2)),1,40);

If CNum=0 then
  begin
      WlnWrite(CW,'***  choices:');
       WlnWrite(CW,'WINDOW     QUIT        JOIN        PART        /         MSG');
       WlnWrite(CW,'NOTICE     VERSION     LIST        TOPIC       NAMES     INVITE');
       WlnWrite(CW,'KICK       STATS       LINKS       TIME        DATE      INFO');
       WlnWrite(CW,'QUOTE      RAW         WHOIS       HELP        KILL      MOTD');
       WlnWrite(CW,'CLS        CLEAR       MODE        SERVER      LUSERS    SET');
       WlnWrite(CW,'NICK       WHO         ME          DESCRIBE    WHOWAS    CTCP');
       WlnWrite(CW,'DCC        AWAY        ISON        ADMIN       WALLPOS   OPER');
       WlnWrite(CW,'SUMMON     DMSG        PING        USERHOST    USERS     HISTORY');
       WlnWrite(CW,'ENCRYPT*   NSLOOKUP    FINGER      STATUS      ST        CD');
       WlnWrite(CW,'EXEC       MORE        GO');
       WlnWrite(CW,' ');
       WlnWrite(CW,'---Other and New Commands--- (Newer cmds may not be implemented on all ircds)');
       WlnWrite(CW,'RESTART    CONNECT     RECONNECT   SQUIT       TRACE     UMODE*');
       WlnWrite(CW,'SERVICE*   REHASH      HSAH*       HAZH*       DIE       CLOSE* ');
       WlnWrite(CW,'KLINE      TKLINE      SQUERY      SERVLIST    DNS       MAP    ');
       WlnWrite(CW,'Keys');
       WlnWrite(CW,'   * = not totally implemented ');
{      WlnWrite(CW,'*** Hit any key to end ***'); }
     exit;
  end;
If (CFirst='KEYS') then
  begin
    WlnWrite(CW, '? SPECIAL KEYS');
    WlnWrite(CW, '?');
    WlnWrite(CW, '?  F5     = Cycle through the active channels in the current window');
    WlnWrite(CW, '?  F6     = Cycle through the active windows');
    WlnWrite(CW, '?  Alt-F9 = Log incoming IRC commands to DEBUGIRC.LOG');
    WlnWrite(CW, '?  ^R     = Redisplay current command line');
    WlnWrite(CW, '?  ^Q     = Quote next character (not currently implemented)');
    WlnWrite(CW, '?  ^E     = Escape following characters from encryption (not implemented)');
    WlnWrite(CW, '?  Up     = Go back through the command-line history');
    WlnWrite(CW, '?  Down   = Move down through the command-line history');
    WlnWrite(CW, '?  ScrLock= When enabled display the entire IRC command received from server');
    WlnWrite(CW, '?  ^E     = Escape following characters from encryption (not implemented)');
  end;
If (CFirst='ST') or (CFirst='STATUS') then
  begin
    WlnWrite(CW, '? "STATUS / ST"   Usage:  /STATUS [CFG|HB]');
    WlnWrite(CW, '?');
    WlnWrite(CW, '?  Display some status information.   With the CFG option');
    WlnWrite(CW, '?  this will display some of the configuration stuff.  With');
    WlnWrite(CW, '?  the HB option it will display jpIRC''s heartbeat info.');
  end;
If CFirst='/' then
  begin
    WlnWrite(CW, '? "/"   Usage:  // <msg>');
    WlnWrite(CW, '?');
    WlnWrite(CW, '?  Alias for last "/MSG <user> <msg>" command');
    exit;
  end;
If CFirst='MAP' then
  begin
    WlnWrite(CW, '? "MAP"   Usage:  /MAP');
    WlnWrite(CW, '?');
    WlnWrite(CW, '?  On some newer servers this command exists.  It will display a tree map ');
    WlnWrite(CW, '?  of the servers connected to this the IRC network.');
   exit;
  end;
If CFirst='HB' then
  begin
    WlnWrite(CW, '? "HB"   Usage:  /HB');
    WlnWrite(CW, '?');
    WlnWrite(CW, '?  Force jpIRC to do a heartbeat.   Currently heartbeats ');
    WlnWrite(CW, '?  just update the Check POP3 Mail timer.  Future plans  ');
    WlnWrite(CW, '?  would be to send a PING or a PRIVMSG to ourself to avoid ');
    WlnWrite(CW, '?  a timeout when getting long channel lists');
    exit;
  end;
If CFirst='GO' then
  begin
    WlnWrite(CW, '? "GO"   Usage:  /GO');
    WlnWrite(CW, '?');
    WlnWrite(CW, '?  used to continue on with a /MORE  (see /MORE)');
    exit;
  end;
If CFirst='MORE' then
  begin
    WlnWrite(CW, '? "MORE"   Usage:  /MORE <filename>');
    WlnWrite(CW, '?');
    WlnWrite(CW, '?  used to display about 20 lines of a file at a time, pausing after ever');
    WlnWrite(CW, '?  20 lines.  use /GO to continue scrolling down through the file.');
    WlnWrite(CW, '?  To close the file you can go /MORE with no filename after it');
    exit;
  end;



WlnWrite(CW, 'No Help on "'+CLine+'"');

END;


Procedure InitHlp;
Begin
  TmpStr:='';
  asm nop end;
End;

{$F+}
Procedure HLP_NewExitProc; far;
 begin
   ExitProc:=SaveExitProc;
 end;


BEGIN
 SaveExitProc:=ExitProc;
 ExitProc:=@HLP_NewExitProc;
 InitHlp;

END.    (C) 1997 - Copyright ParSoft, by Jeff Patterson


