{$UNDEF OURICMP}
{$IFDEF OVERLAY}
{$O+}
{$ENDIF}
Unit JPIRCSET;

Interface

Uses JP_UNIT, XSTRING, JPIRCVAR, JPIRCCIN, JPIRCWIN, JPIRC_HB,
{$IFDEF OURICMP}
     JPI_ICMP,
{$ENDIF}
     ABI_JP, JPIRCDCC;

Procedure ProcessSetCMD(CLine:String);

Implementation

Procedure ProcessSetCMD(CLine:String);
var TmpB : Boolean;
    CFirst,CSecond,CThird : String[80];
    CNum : Word;
    TmpStr:String;
    A : String;
    W : Word;
    I, Result : Integer;

Begin
   CNum := PARSENFN(CLine);
   CFirst := UCase(PARSERFN(CLine, 1));
   CSecond:= UCase(PARSERFN(CLine, 2));
   CThird := UCase(PARSERFN(CLine, 3));
If (CFirst = 'DEBUGLOG') and (CNum>1) then
  begin
    DebugLogFlag := WasTrueFalse(CSecond);
  end;
If (CFirst = 'CHKMAIL') and (CNum>1) then DoChkMail := WasTrueFalse(CSecond);
If (CFirst = 'VERBOSE_CTCP') and (CNum>1) then VerboseCTCP := WasTrueFalse(CSecond);
{$IFDEF OURICMP}
If (CFirst = 'VERBOSE_ICMP') and (CNum>1) then ICMPverbose := WasTrueFalse(CSecond);
{$ENDIF}
If (CFirst = 'REALNAME') and (CNum>1) then User.RealName := PARSERREST(CLine, 2);
If (CFirst = 'USERNAME') and (CNum>1) then User.UserName := PARSERREST(CLine, 2);
If (CFirst = 'HOSTNAME') and (CNum>1) then User.HostName := PARSERREST(CLine, 2);
If (CFirst = 'POP3USER') and (CNum>1) then Pop3User^ := PARSERREST(CLine, 2);
If (CFirst = 'POP3PASSWORD') AND (CNum>1) then Pop3Pass^ := PARSERREST(CLine, 2);
If (CFirst = 'POP3SERVER') and (CNum>1) then Pop3Server^ := PARSERREST(CLine,2);
If CNum>0 then
  begin
    If (CFirst='DEBUGLOG') then
        begin
          If DebugLogFlag then TmpStr:='TRUE'  else TmpStr:='FALSE';
          WlnWrite(CW, '*** Current value of DEBUGLOG = '+TmpStr);
          exit;
        end;
    If (CFirst='VERBOSE_CTCP') then
        begin
          If VerboseCTCP then TmpStr:='TRUE'  else TmpStr:='FALSE';
          WlnWrite(CW, '*** Current value of VERBOSE_CTCP = '+TmpStr);
          exit;
        end;
    If (CFirst='CHKMAIL') then
        begin
          If DoChkMail then TmpStr:='TRUE'  else TmpStr:='FALSE';
          WlnWrite(CW, '*** Current value of CHKMAIL = '+TmpStr);
          exit;
        end;
    If (CFirst='POP3USER') then
        begin
          WlnWrite(CW, '*** Current value of POP3USER = "'+Pop3User^+'"');
          exit;
        end;
    If (CFirst='POP3PASSWORD') then
        begin
          WlnWrite(CW, '*** Current value of POP3PASSWORD = "'+Pop3Pass^+'"');
          exit;
        end;
    If (CFirst='POP3SERVER') then
        begin
          If not ip_lookup(Pop3Server^, Pop3IPAddr) then
              begin
                WlnWrite(CW, 'Unable to resolve Pop3 Server '+Pop3Server^);
                Pop3Server^ := '';
              end;
          WlnWrite(CW, '*** Current value of POP3SERVER = "'+Pop3Server^+'"');
          exit;
        end;

{$IFDEF OURICMP}
    If (CFirst='VERBOSE_ICMP') then
        begin
          If ICMPverbose then TmpStr:='TRUE'  else TmpStr:='FALSE';
          WlnWrite(CW, '*** Current value of VERBOSE_ICMP = '+TmpStr);
          exit;
        end;
{$ENDIF}
    If (CFirst='REALNAME') then
        begin
          WlnWrite(CW, '*** Current value of REALNAME = "'+User.RealName+'"');
          exit;
        end;
    If (CFirst='USERNAME') then
        begin
          WlnWrite(CW, '*** Current value of USERNAME = "'+User.UserName+'"');
          exit;
        end;
    If (CFirst='HOSTNAME') then
        begin
          WlnWrite(CW, '*** Current value of HOSTNAME = "'+User.HostName+'"');
          exit;
        end;
    WlnWrite(CW, 'Unknown variable: '+CFirst);
    exit;
  end;
If CNum=0 then
 Begin
          If DebugLogFlag then TmpStr:='TRUE'  else TmpStr:='FALSE';
          WlnWrite(CW, '*** Current value of DEBUGLOG     = '+TmpStr);
          If DoChkMail then TmpStr:='TRUE'  else TmpStr:='FALSE';
          WlnWrite(CW, '*** Current value of CHKMAIL      = '+TmpStr);
          WlnWrite(CW, '*** Current value of POP3USER     = '+Pop3User^);
          WlnWrite(CW, '*** Current value of POP3PASSWORD = '+Pop3Pass^);
          WlnWrite(CW, '*** Current value of POP3SERVER   = '+Pop3Server^);
          If VerboseCTCP then TmpStr:='TRUE'  else TmpStr:='FALSE';
          WlnWrite(CW, '*** Current value of VERBOSE_CTCP = '+TmpStr);
{$IFDEF OURICMP}
          If ICMPverbose then TmpStr:='TRUE'  else TmpStr:='FALSE';
          WlnWrite(CW, '*** Current value of VERBOSE_ICMP = '+TmpStr);
{$ENDIF}
          WlnWrite(CW, '*** Current value of REALNAME     = '+User.RealName);
          WlnWrite(CW, '*** Current value of USERNAME     = '+User.UserName);
          WlnWrite(CW, '*** Current value of HOSTNAME     = '+User.HostName);
  exit;
 End;

WlnWrite(CW, 'Unknown variable: '+CFirst);
End;


BEGIN
END.

