
Unit JPIRC_IN;     { Incoming messages from server, processing etc... }

Interface

Uses DOS, ABI, ABI_DOM, ABI_JP, JP_UNIT, XSTRING,
     JPIRCCMD, JPIRCWIN, JPIRCVAR, JPIRCCIN;

var
  TmpToggle  : Boolean;
  DoingList:Integer;


Procedure ProcessIncomingMSG;
Procedure ProcessIncomingIO;

Implementation

CONST MQUOTE = ^P;

Procedure ProcessIncomingIO;
var Result:Word;
    W     : Word;
    TmpStr:String;
    TmpBuffer:BufferREC;
Begin
  If not Online then exit;
  If IRCS.DAT.ReadCRLF then
    begin
      CIN_Buff.Length:=0;
      CIN_Line:='';
    end;
  IRCS.Buffer.Length:=0;
  CIN_Valid:=False;
  CIN_prefix:='';
  If Online then Result:=tcp_get(IRCS, 3, 0);

  CIN_Valid:=False;
  If IRCS.Buffer.Length=0 then
       begin
         IRCS.DAT.ReadCRLF:=False;
         exit;
       end;

  CIN_Line:='';
  Move(IRCS.Buffer.Buffer, CIN_Buff.Buffer[CIN_Buff.Length +1 ], IRCS.Buffer.Length);
  CIN_Buff.Length:=CIN_Buff.Length + IRCS.Buffer.Length ;

  If (IRCS.DAT.ReadCRLF) then
     Begin
       CIN_Line:=ShowBuffer(CIN_Buff, 6);

       ProcessIncomingCIN_Buff;
       CIN_Line:=ShowBuffer(CIN_Buff, 6);
       CIN_Valid:=True;

       IRCS.Buffer.Length:=0;
       exit
     End;

End;

(********
Procedure HandleNames(CLine:String);
Begin
   TmpStr:='Unk: ';
   A:=PARSERFN(CIN_Line,4);
   If Copy(A,1,1)='#' then TmpStr:='Pub: ';
   If Copy(A,1,1)='&' then TmpStr:='Pvt: ';
   TmpStr:=TmpStr+A+'      '+PARSERREST(CIN_Line,5);
   WlnWrite(CW,TmpStr);
End;
********)

Procedure Process__NAMES;
var W : Word;
    I : Integer;
    CNum :Word;
    A,B,C:String;
    TmpStr:String;
Begin
  TmpStr:='Unk: ';
  C:=BPARSERFN(CIN_Buff, 4);
  If Copy(C,1,1)='#' then TmpStr:='Pub: ';
  If Copy(C,1,1)='&' then TmpStr:='Pvt: ';
  If C='*' then TmpStr:='None:';

  TmpStr:=TmpStr+' '+C+'     '+BPARSERREST(CIN_Buff, 5);
  CNum:=BPARSENFN(CIN_Buff);
  I:=5;
  repeat
    B:=BPARSERFN(CIN_Buff, I);
    A:=Copy(B,1,1);
    If A=':' then
      Begin
        Delete(B,1,1);
        A:=Copy(B,1,1);
      End;
    If (A='@') or (A='+') then Delete(B,1,1);
    If Ucase(B)=UCase(User.Nick) then
      Begin
         For W:=1 to MaxChannels do
            begin
              If CHA^[W].Name = C then
                  begin
                    If A='@' then CHA^[W].o := True
                             else CHA^[W].o := False;
                    If A='+' then CHA^[W].v := True
                             else CHA^[W].v := False;
                  end;
            end;
      End;
    Inc(I);
  until I>CNum;
 WlnWrite(CW, TmpStr);

End;


Procedure ProcessIncomingMSG;
var CFirst, CSecond, CThird:String;
    CNum : Word;
    I: Integer;
    W: Word;
    TmpLong:LongInt;
    TmpStr:String;
    A:String;
    Result:Integer;
    DoAdd:Boolean;
    MsgRep:String;
Begin
 If (not CIN_Valid) or (Length(CIN_Line)=0) then exit;
 { If IsScrLock then WlnAWrite(CW, CIN_Buff); }
 Str(PARSENFN(CIN_Line),TmpStr);
{ If IsScrLock then WlnWrite(CW, TmpStr+' "'+CIN_PAddr+'"');}
  CNum   := PARSENFN(CIN_Line);
  CFirst := UCase(PARSERFN(CIN_Line, 1));
  CSecond:= UCase(PARSERFN(CIN_Line, 2));
  If Length(CSecond)=0 then CSecond[1]:=#0;
  CThird := UCase(PARSERFN(CIN_Line, 3));
 If (CFirst='PING') then
         Begin
           TmpStr:=CIN_PAddr+CIN_PNick;
           TmpStr:=PARSERREST(CIN_Line, 2);
           If TmpStr='' then TmpStr:=User.servername;
           tcp_sendtextln(IRCS, 'PONG '+TmpStr);
           WlnWrite(CW,' <PING rcvd, PING sent>');
           exit;
         End;
 If (CFirst='NICK') then
         Begin
           TmpStr:=CIN_Line;
           TmpStr:='*** '+CIN_PNick+' is now known as '+PARSERREST(CIN_Line,2);
           If CIN_PNick=User.Nick then User.Nick:=PARSERREST(CIN_Line,2);
           WlnWrite(CW, TmpStr);
           exit;
         End;
 If (CFirst='PRIVMSG') then
   begin
     TmpStr:=CIN_Line;
     W:=CW;
     If CSecond=UCase(User.Nick) then
          begin
             TmpStr:='*'+CIN_PNick+'* ';
        end else begin
             TmpStr:='<'+CIN_PNick+'> ';
             For I:=1 to MaxWindows do
                begin
                  If CSecond=UCase(CHA^[WindowA^[I].CCH].Name) then
                        begin
                          W:=I;
                          Break;
                        end;
                end;
             If W <> CW then TmpStr := '<'+CIN_PNick+': '+PARSERFN(CIN_Line,2)+'> ';
          end;
     WlnWrite(W, TmpStr);
     If Length(CIN_Line)<242 then
         begin
           WWrite(W, PARSERREST(CIN_Line,3));
        end else begin
           WlnAWrite(W, CIN_Buff);
         end;
     exit;
   end;
 If (CFirst='NOTICE') then
   begin
     TmpStr:=CIN_Line;
     TmpStr:='---';
     W:=CW;
     If CSecond=UCase(User.Nick) then
          begin
             If CIN_PAddr<>'' then TmpStr:='- ';
             If CIN_PNick<>'' then TmpStr:='-'+CIN_PNick+'- ';
        end else begin
             If CIN_PAddr<>'' then TmpStr:='} ';
             If CIN_PNick<>'' then TmpStr:='-'+CIN_PNick+'} ';
             For I:=1 to MaxWindows do
                begin
                  If CSecond=UCase(CHA^[WindowA^[I].CCH].Name) then
                          begin
                            W:=I;
                            Break;
                          end;
                end;
          end;
     WlnWrite(W, TmpStr);
     If Length(CIN_Line)<242 then
         begin
           TmpStr:=PARSERREST(CIN_Line,3);
           WWrite(W, TmpStr);
           If Copy(TmpStr,1,24)='Got Ident resposePING :' then
             BEGIN
               WlnWrite(W, 'Found NewNet''s PING BUG (EOL problem?) - ');
               CThird:='PONG '+Copy(TmpStr,24, Length(TmpStr));
               tcp_sendtextln(IRCS, CThird);
               WWrite(CW, '<PING rcvd, PONG sent>');
             END;
        end else begin
           WlnAWrite(W, CIN_Buff);
         end;
     exit;
   end;
 If (CFirst='PART') and (CIN_PNick=User.Nick) then
     begin
       For I:=1 to MaxChannels do
          begin
            If (UCase(CHA^[I].Name)=CSecond) or (UCase(':'+CHA^[I].Name)=CSecond) then
                 begin
                   CHA^[I].Name:='';
                   CHA^[I].o := False;  CHA^[I].v := False;
                   For W:=1 to MaxWindows do
                      begin
                         If WindowA^[W].CCH=I then WindowA^[W].CCH:=0;
                      end;
                 end;
          end;
     end;
 If (CFirst='JOIN') and (CIN_PNick=User.Nick) then
     begin
       DoAdd:=False;
       For I:=1 to MaxChannels do
          begin
            If CHA^[I].Name='' then
               begin
                 DoAdd:=True;
                 break;
               end;
          end;
        WlnWrite(CW, '%%%  We Are joining channel ');
                                                                               { NEW 98 }
       A := PARSERREST(CIN_Line,2);  TmpStr := '';
       If Pos(#7,A)>0 then
         begin
           TmpStr := Copy(A, Pos(#7,A)+1, 50);
           A := Copy(A, 1, Pos(#7,A)-1);
           If DoAdd then
             Begin
                For I := 1 to Length(TmpStr) do
                 begin
                   case UpCase(TmpStr[I]) of
                      'O' : CHA^[I].o := True;
                   end;
                 end;
             End;
         end;
       If Pos(#32,A)>0 then
         begin
           TmpStr := TmpStr + ' ' + Copy(A, Pos(#32,A)+1, 50);
           A := Copy(A, 1, Pos(#32,A)-1);
         end;

       If DoAdd then
            begin
               WindowA^[CW].CCH := I;
               CHA^[I].Name := Copy(A,1,200);
               WlnWrite(CW, '%%%  We HAVE just joined channel "'+A+'"');
               WWrite(CW, ', '+LeadingZero(WindowA^[CW].CCH,2));
               tcp_sendtextln(IRCS, 'MODE '+CHA^[I].Name);
           end else begin
               WlnWrite(CW, '!!! Space for Channel not found, channel not joined');
               tcp_sendtextln(IRCS, 'PART '+A);
               exit;
            end;
     end;
 If (CFirst='MODE') and (PARSERFN(CIN_Line, 2)= User.Nick) { (CIN_PNick=User.Nick) } then
         Begin
           DoAdd:=True;
           For I:=1 to length(CThird) do
              Begin
                Case CThird[I] of
                  ':' : ;
                  '+' : DoAdd:=True;
                  '-' : DoAdd:=False;
                  'I' : If DoAdd then User.i:=True  else User.i:=False;
                  'S' : If DoAdd then User.s:=True  else User.s:=False;
                  'W' : If DoAdd then User.w:=True  else User.w:=False;
                  'O' : If DoAdd then User.o:=True  else User.o:=False;
                  'R' : If DoAdd then User.r:=True  else User.r:=False;
                   Else
                      Str(Ord(CThird[I]), A);
                      WlnWrite(CW, 'Unknown Mode '+CThird[I]+', '+A);
                 End;
              End;
         End;

 If (CFirst='JOIN') then
         Begin
           TmpStr:='*** '+CIN_PNick+' ('+CIN_PUser+'@'+CIN_PHost+') has joined channel '+PARSERREST(CIN_Line,2);
           WlnWrite(CW, TmpStr);
           exit;
         End;
 If (CFirst='PART') then
         Begin
           TmpStr:='*** '+CIN_PNick+' has left channel '+PARSERFN(CIN_Line,2);
           WlnWrite(CW, TmpStr);
           exit;
         End;
 If (CFirst='QUIT') then
         Begin
           TmpStr:='*** Signoff: '+CIN_PNick+' ('+PARSERREST(CIN_Line,2)+')';
           If CIN_PNick=LastPRIVMSG then LastPRIVMSG:='';
           WlnWrite(CW, TmpStr);
           exit;
         End;
 If (CFirst='TOPIC') then
         Begin
            TmpStr:=PARSERFN(CIN_Line,2);
            WlnWrite(CW, '*** Topic for '+TmpStr+': '+PARSERREST(CIN_Line, 3));
            W:=0;
            For I:=1 to MaxChannels do
             Begin
              If UCase(CHA^[I].Name)=CSecond then
                  begin
                    W:=I;
                    break;
                  end;
             End;
            If W=0 then
              begin
                exit;
              end;
            CCH:=W;
            TmpStr:=PARSERREST(CIN_Line,3);
            CHA^[CCH].Topic:=TmpStr;
         End;
 If (CFirst='KILL') then
         Begin
           TmpStr:='*** ';
           If User.Nick=PARSERFN(CIN_Line,2) then
                     TmpStr:=TmpStr+'YOU! ('+PARSERFN(CIN_line,2)+') '
                   else
                     TmpStr:=TmpStr+PARSERFN(CIN_Line, 2)+' ';
           TmpStr:=TmpStr+' have been KILLed by Server Operator '+CIN_PNick;
           TmpStr:=TmpStr+' ('+PARSERREST(CIN_line,3)+')';
           WlnWrite(CW, TmpStr);
          exit;
         End;
 If (CFirst='KICK') then
         Begin
           TmpStr:='*** ';
           If User.Nick=PARSERFN(CIN_Line,2) then
                     TmpStr:=TmpStr+'YOU! ('+PARSERFN(CIN_line,3)+') have '
                   else
                     TmpStr:=TmpStr+PARSERFN(CIN_Line, 3)+' has ';
           TmpStr:=TmpStr+' been kicked off of '+PARSERFN(CIN_Line, 2)+
                          ' by '+CIN_PNick+' ('+PARSERREST(CIN_Line,4)+')';
           WlnWrite(CW, TmpStr);
          exit;
         End;
 If (CFirst='MODE') and  ( (CSecond[1]='#') or (CSecond[1]='&') ) then
         Begin
           For I:=1 to MaxChannels do
                begin
                 If (UCase(CHA^[I].Name)=CSecond) or (UCase(':'+CHA^[I].Name)=CSecond) then
                     begin
                         DoAdd:=True;
                         W:=4;
                         For I:=1 to length(CThird) do
                            Begin
                              Case CThird[I] of
                                '+' : DoAdd:=True;
                                '-' : DoAdd:=False;
                                'P' : If DoAdd then CHA^[I].p:=True  else CHA^[I].p:=False;
                                'S' : If DoAdd then CHA^[I].s:=True  else CHA^[I].s:=False;
                                'I' : If DoAdd then CHA^[I].i:=True  else CHA^[I].i:=False;
                                'T' : If DoAdd then CHA^[I].t:=True  else CHA^[I].t:=False;
                                'N' : If DoAdd then CHA^[I].n:=True  else CHA^[I].n:=False;
                                'M' : If DoAdd then CHA^[I].m:=True  else CHA^[I].m:=False;
                                'L' : Begin
                                        If DoAdd then
                                            Begin
                                             A:=PARSERFN(CIN_Line, W);
                                             Val(A, CHA^[I].UserLimit, Result);
                                             If Result<>0 then CHA^[I].UserLimit :=0;
                                             If W<CNum then Inc(W);
                                            End;
                                        If not DoAdd then CHA^[I].UserLimit :=0;
                                      End;
                                'K' : Begin
                                         If DoAdd then
                                           Begin
                                             CHA^[I].Key := PARSERREST(CIN_Line, W);  {PARSERFN}
                                             If W<CNum then Inc(W);
                                           End;
                                         If not DoAdd then CHA^[I].Key := '';
                                      End;
                               End;
                            End;

                     end;
                end;
           TmpStr:='*** Mode changed "'+PARSERREST(CIN_Line,3)+'" on channel '+
                   PARSERFN(CIN_Line,2)+' by '+CIN_PNick;
           WlnWrite(CW, TmpStr);
           exit;
         End;
 If (CFirst='MODE') and  ( (CSecond[1]<>'#') and (CSecond[1]<>'&') ) then
         Begin
           TmpStr:='*** Mode changed "'+PARSERREST(CIN_Line,3)+'" for user '+
                   PARSERFN(CIN_Line,2)+' by '+CIN_PNick;
           WlnWrite(CW, TmpStr);
           exit;
         End;
 If  (CFirst='REQCTCP')  then
         Begin
           TmpStr:='*** CTCP '+PARSERFN(CIN_Line, 3)+' from '+CIN_PNick+': '+PARSERREST(CIN_Line,4);
           WlnWrite(CW, TmpStr);
           WlnWrite(1, '=CTCP===('+CIN_Line+')');
           exit;
         End;
 If ( CFirst='REPCTCP')  then
         Begin
           TmpStr:='*** CTCP '+PARSERFN(CIN_Line, 3)+' reply from '+CIN_PNick+': '+PARSERREST(CIN_Line,4);
           WlnWrite(CW, TmpStr);
           exit;
         End;


 TmpStr:=PARSERFN(CIN_Line,3);
 MsgRep:='';
 
 If IsScrLock then WlnWrite(CW, '"'+CIN_Line+'"');
Case Msg.Res of
  0   : Begin
           MsgRep:='';
           For W:=2 to CNum do
             begin
               If Copy(PARSERFN(CIN_Line,W),1,1)=':' then
                   begin
                     MsgRep:=MsgRep+Copy(PARSERFN(CIN_Line,W),2,Length(PARSERFN(CIN_Line,W)));
                   end else begin
                     MsgRep:=MsgRep+PARSERFN(CIN_Line,W);
                   end;
               If W<>CNum then MsgRep:=MsgRep+' ';
             end;
            If MsgRep<>'' then WlnWrite(CW,MsgRep);
            If IsScrLock then WlnAWrite(CW, CIN_Buff);
        End;
1..99 : WlnWrite(CW, '*** '+PARSERREST(CIN_Line, 3));
101..199 : WlnWrite(CW, 's** '+PARSERREST(CIN_Line, 3));

{211 Nick <linkname> <sendq> <sent msgs> <sent bytes> <rcvd msgs> <rcvd bytes> <time open>}
  211 : WlnWrite(CW, '. '+PARSERREST(CIN_Line, 3));
{212 Nick <command> <count>}
  212 : Begin
          If DoingList<>212 then
            Begin
              DoingList:=212;
              WlnWrite(CW, '  Command   Count');
              WlnWrite(CW, '  =======   =====');
            End;
          WlnWrite(CW, '   '+TmpStr+'  '+PARSERFN(CIN_line, 4));
        End;
{213 Nick C <host> * <name> <port> <class>}
  213 : Begin
          If DoingList<>213 then
            Begin
              DoingList:=213;
              WlnWrite(CW, '  Host             Name       Port    Class');
              WlnWrite(CW, '  ==============   ========   ======  =====');
            End;
          WlnWrite(CW, PARSERREST(CIN_Line, 3));
        End;
{214 Nick N <host> * <name> <port> <class>}
{215 Nick I <host> * <name> <port> <class>}
{216 Nick K <host> * <username> <port> <class>}
  214, 215, 216,
  218, 241, 243, 244  : WlnWrite(CW, PARSERREST(CIN_Line, 3));
{218 Nick Y <class> <ping frequency> <connect frequency> <max sendq>}
{241 Nick L <hostmask> * <servername> <maxdepth>}
{243 Nick O <hostmask> * <name>}
{244 Nick H <hostmask> * <servername>}

  219 : Begin
          TmpStr:='*** End of /STATS for ';
          Case CThird[1] of
              'C' : TmpStr:=TmpStr+'C lined (Servers allowed to connect  (C and N Lines)';
              'N' : TmpStr:=TmpStr+'N lined (names of servers allowed to connect)';
              'I' : TmpStr:=TmpStr+'I lined (Who CAN connect to a server)';
              'K' : TmpStr:=TmpStr+'K lined (Banned (or at what time they are banned))';           {216}
              'Y' : TmpStr:=TmpStr+'Y lined (List of the various connection classes)';             {218}
              'L' : TmpStr:=TmpStr+'L lined (Info Re: amount of info passed to servers & users)';  {211}
              'O' : TmpStr:=TmpStr+'O lined (List of authorized Operator on this server)';         {243}
              'H' : TmpStr:=TmpStr+'H lined (Hubs)';
              '*' : TmpStr:=TmpStr+'* (Server STATS type Unknown)';
              'U' : TmpStr:=TmpStr+'U (Uptime)';                                                   {242}
              'T' : TmpStr:=TmpStr+'T (Various Statistics)';                                     {R=249}
              'Z' : TmpStr:=TmpStr+'Z (Various Statistics)';                                       {249}
              'M' : TmpStr:=TmpStr+'M (Command Usage Statistics (a tally))';                       {212}
  'Q','S','H','X','C'  : TmpStr:=TmpStr+PARSERFN(CIN_Line,3);
             Else
                TmpStr:=TmpStr+PARSERFN(CIN_Line,3);
            End;
          WlnWrite(CW,TmpStr);
        End;
  221 : Begin
          WlnWrite(CW, '* * Mode for '+PARSERFN(CIN_Line,2)+' is '+TmpStr);
          If User.Nick=PARSERFN(CIN_Line,2) then
            begin
              User.i:=False;  User.s:=False; User.w:=False;  User.o:=False;
              For I:=1 to Length(CThird) do
                begin
                 Case CThird[I] of
                   'I' : User.i :=True;
                   'S' : User.s :=True;
                   'W' : User.w :=True;
                   'O' : User.o :=True;
                  End;
                end;
            end;
        End;
                           { 235 = end of service listing ("HELP") }
  235,242 : WlnWrite(CW, '*** '+PARSERREST(CIN_Line, 3));
  249,250, 251 : Begin
         WlnWrite(CW, '*** '+PARSERREST(CIN_Line, 3));
        End;
  252,253,254,
  256          : WlnWrite(CW, '*** '+PARSERFN(CIN_Line, 3)+' '+PARSERREST(CIN_Line,4));
  255,257,258,259 : WlnWrite(CW, '*** '+PARSERREST(CIN_Line, 3));
  265, 266, 272 : WlnWrite(CW, '*** '+PARSERREST(CIN_Line,3));

  300 : WlnWrite(CW, '(300 no reply)');
  301 : WlnWrite(CW, '*** '+TmpStr+' is away: '+PARSERREST(CIN_Line,4));
  302 : WlnWrite(CW, '* * '+PARSERREST(CIN_Line, 3));
  303 : Begin
         TmpStr:=PARSERREST(CIN_Line,3);
         WlnWrite(CW, '* * ISON:');
         For I:=1 to PARSENFN(TmpStr) do
           begin
             WlnWrite(CW, '* * '+PARSERFN(TmpStr,I));
           end;
          { This will be processed by /NOTIFY, if a toggle is detected then }
          { If true then : '*** Signon by <user> detected'  }
          { If false then: '*** Signoff by <user> detected' }
          { If /NOTIFY + then '*** Currently absent: <user>' }
          {                or '***    ???????????  : <user>' }
        End;
  305 : Begin
         WlnWrite(CW, '*** You are no longer marked as being away');
         User.WeAway := False;
        End;
  306 : Begin
         WlnWrite(CW, '*** You have been marked as being away');
         User.WeAway := True;
        End;
  311 : WlnWrite(CW, '*** '+TmpStr+' is '+PARSERFN(CIN_Line,4)+'@'+PARSERFN(CIN_Line,5)+' ('+
                                          PARSERREST(CIN_Line,7)+')');
  312 : WlnWrite(CW, '*** on irc via server '+PARSERFN(CIN_Line,4)+' ('+
                                   PARSERREST(CIN_Line,5)+')');
  313 : WlnWrite(CW, '*** '+TmpStr+' is an IRC operator');
  314 : WlnWrite(CW, '*** '+TmpStr+' was '+PARSERFN(CIN_Line,4)+'@'+PARSERFN(CIN_Line,5)+' ('+
                                          PARSERREST(CIN_Line,7)+')');
  315 : ; { WlnWrite(CW, '* * End of /WHO List'); }
  317 : Begin
          If Copy(PARSERFN(CIN_Line,5),1,1)=':' then
            begin
               WlnWrite(CW, '*** '+TmpStr+' has been idle '+PARSERFN(CIN_Line,4)+' '+
                                                     PARSERREST(CIN_Line,5));
           end else begin
               WlnWrite(CW, '*** '+TmpStr+' has been idle '+PARSERFN(CIN_Line,4)+' and logged in at: ');
               TmpLong:=ULVal( PARSERFN(CIN_Line,5) );
               ShowUnixDate(TmpLong);
            end;
        End;
  318 : ; { WlnWrite(CW, '* * End of /WHOIS List'); }
  319 : WlnWrite(CW, '*** on channels: '+PARSERREST(CIN_Line,4));

  321 : WlnWrite(CW, 'Channel Users  Topic');
  322 : WlnWrite(CW, TmpStr+' '+PARSERFN(CIN_Line,4)+'  '+PARSERREST(CIN_Line,5));
  323 : WlnWrite(CW, '*** end of list');

  324 : Begin
          If PARSERREST(CIN_Line,4)<>'+' then
               WlnWrite(CW, '* * Channel Mode for '+TmpStr+' is '+PARSERREST(CIN_Line,4)+'.');
          W:=0;
          For I:=1 to MaxChannels do
           Begin
            If UCase(CHA^[I].Name)=UCase(TmpStr) then
                begin
                  W:=I;
                  break;
                end;
           End;
          If W=0 then
            begin
              exit;
            end;
          CCH:=W;
          TmpStr:=UCase(PARSERFN(CIN_Line,4));
          CHA^[I].p :=False;  CHA^[I].s :=False;  CHA^[I].i :=False;  CHA^[I].t :=False;
          CHA^[I].n :=False;  CHA^[I].m :=False;  CHA^[I].UserLimit:=0;
          CHA^[I].Key:='';
          W:=5;
          For I:=1 to Length(TmpStr) do
           begin
            CASE TmpStr[I] of
              ' ' : ;
              '+' : ;
              'P' : CHA^[CCH].p := True;
              'S' : CHA^[CCH].s := True;
              'I' : CHA^[CCH].i := True;
              'T' : CHA^[CCH].t := True;
              'N' : CHA^[CCH].n := True;
              'M' : CHA^[CCH].m := True;
              'K' : Begin
                      CHA^[CCH].Key:=PARSERREST(CIN_Line, W);  {PARSERFN}
                      If W<CNum then Inc(W);
                    End;
              'L' : Begin
                      A:=PARSERFN(CIN_Line,W);
                      Val(A, CHA^[CCH].UserLimit, Result);
                      If Result<>0 then CHA^[CCH].UserLimit:=0;
                      If W<CNum then Inc(W);
                    End;
               Else
                   Str(Ord(TmpStr[I]), A);
                   WlnWrite(CW,'FOUND Unknown mode "'+TmpStr[I]+'" (dec'+A+')');
             END;

           end;
        End;
  331 : WlnWrite(CW, '*** No topic is set for '+TmpStr);
  332 : Begin
          WlnWrite(CW, '*** Topic for '+TmpStr+': '+PARSERREST(CIN_Line, 4));
          W:=0;
          For I:=1 to MaxChannels do
           Begin
            If UCase(CHA^[I].Name)=UCase(TmpStr) then
                begin
                  W:=I;
                  break;
                end;
           End;
          If W=0 then
            begin
              exit;
            end;
          CCH:=W;
          TmpStr:=PARSERREST(CIN_Line,4);
          CHA^[CCH].Topic:=TmpStr;
        End;
  328 : Begin
          TmpStr:='* * Website? for channel '+PARSERFN(CIN_Line,3)+' is '+PARSERREST(CIN_Line,4);
          WlnWrite(CW, TmpStr);
        End;
  329 : Begin
          TmpStr:='*** Channel '+PARSERFN(CIN_Line,3)+' was created on ';
          WlnWrite(CW, TmpStr+' ');
          TmpLong:=ULVal( PARSERFN(CIN_Line,4) );
          If (CCH>0) and (CCH<=MaxChannels) then CHA^[CCH].TimeChannel:=TmpLong;
          ShowUnixDate(TmpLong);
        End;
  333 : Begin
          TmpStr:='*** Topic was created by '+PARSERFN(CIN_Line,4);
          WlnWrite(CW, TmpStr+' ');
          TmpLong:=ULVal( PARSERFN(CIN_Line,5) );
          If (CCH>0) and (CCH<=MaxChannels) then CHA^[CCH].TimeTopic:=TmpLong;
          ShowUnixDate(TmpLong);
        End;
  334 : WlnWrite(CW, '*** '+PARSERREST(CIN_Line,3));
  341 : WlnWrite(CW, '*** You are being invited by '+PARSERFN(CIN_Line,4)+' to join channel '+TmpStr);
  342 : WlnWrite(CW, '* * Summoning '+TmpStr+' to IRC');
  351 : WlnWrite(CW, '*** Server '+PARSERFN(CIN_Line,4)+': '+PARSERFN(CIN_Line,3)+' '+
                                    PARSERREST(CIN_Line,5));
  352 : WlnWrite(CW, TmpStr+'  '+PARSERFN(CIN_Line,7)+'  '+
                            PARSERFN(CIN_Line,8)+'  '+PARSERFN(CIN_Line,4)+'@'+PARSERFN(CIN_Line,5)+
                            ' ('+Copy(PARSERREST(CIN_Line,9),3,Length(CIN_Line))+')');

  353 : Begin
          Process__NAMES;
        End;
  364 : WlnWrite(CW, TmpStr+' '+PARSERFN(CIN_Line,4)+' '+PARSERREST(CIN_Line,5));
  365 : ;  { WlnWrite(CW, '* * end of /LINKS list for '+TmpStr);  }
  366 : ;  { WlnWrite(CW, '* * end of /NAMES list for '+TmpStr);  }
  367 : WlnWrite(CW, 'Banned: '+TmpStr+' '+PARSERFN(CIN_Line,4));
  368 : ;  { WlnWrite(CW, '* * end of channel ban list for '+TmpStr); }
  369 : ;  { WlnWrite(CW, '* * end of /WHOWAS list for '+TmpStr); }
  374 : WlnWrite(CW, '* * end of /INFO list');
  381 : Begin
          WlnWrite(CW, '*** You are now an IRC operator');
          User.IRCop :=True;
        End;
  382 : WlnWrite(CW, '*** Rehashing '+TmpStr);
  391 : WlnWrite(CW, '*** '+PARSERFN(CIN_Line,3)+' '+PARSERREST(CIN_Line,4));

  375, 372, 376, 377, 378 : WlnWrite(CW, '*** '+PARSERREST(CIN_Line,3));
  371,392,393,394,395 : WlnWrite(CW, PARSERREST(CIN_Line,3));

  401 : WlnWrite(CW, '* * No such nick/channel: '+TmpStr);
  402 : WlnWrite(CW, '* * No such server: '+TmpStr);
  403 : WlnWrite(CW, '* * No such channel: '+TmpStr);
  404 : WlnWrite(CW, '* * Cannot send to channel '+TmpStr);
  405 : WlnWrite(CW, '* * You have joined too many channels!  ('+TmpStr+')');
  406 : WlnWrite(CW, '* * There was no such nickname ('+TmpStr+')');
  407 : WlnWrite(CW, '* * Duplicate recipients.  No message delivered ('+TmpStr+')');
  409 : WlnWrite(CW, '* * No origin specified (from a PING/PONG?)');
  411, 412 : WlnWrite(CW, '* * '+PARSERREST(CIN_Line,3));
  413 : WlnWrite(CW, '* * No toplevel domain specified in "'+TmpStr+'"');
  414 : WlnWrite(CW, '* * Wildcard in toplevel domain in "'+TmpStr+'"');
  421 : WlnWrite(CW, '*** Unknown command: '+TmpStr);
  422 : WlnWrite(CW, '* * MOTD File is missing');
  423 : WlnWrite(CW, '* * No administrative info available on '+TmpStr);
  424 : WlnWrite(CW, '* * '+PARSERREST(CIN_Line,3));
  431 : WlnWrite(CW, '* * No nickname given');
  432 : WlnWrite(CW, '* * Erroneus nickname "'+TmpStr+'"');
  433 : WlnWrite(CW, '* * Nickname "'+TmpStr+'" is already in use');
  436 : WlnWrite(CW, '* * Nickname collision KILL '+TmpStr);
  441 : WlnWrite(CW, '* * '+TmpStr+' is not on channel '+PARSERFN(CIN_Line,4));
  442 : WlnWrite(CW, '*** You are not on channel '+TmpStr);
  443 : WlnWrite(CW, '*** '+TmpStr+' is already on channel '+PARSERFN(CIN_Line,4));
  444 : WlnWrite(CW, '*** '+TmpStr+' is not logged in');
  445, 446 : WlnWrite(CW, '* * '+PARSERREST(CIN_Line,3));
  451 : Begin
          WlnWrite(CW, '*** You have not registered');
        End;
  461 : WlnWrite(CW, '*** Not enough parameters for command '+TmpStr);
  462 : Begin
          WlnWrite(CW, '*** You may not reregister');
        End;
  463,464,465 : WlnWrite(CW, '* * '+PARSERREST(CIN_Line,3));

  466 : Begin
          WlnWrite(CW, '*?* Warning:  You will be banned');
          WlnWrite(CW, '*['+CIN_Line+']*');
        End;

  467 : WlnWrite(CW, '*** Channel '+TmpStr+' already has a key set');
  471 : Begin
          WlnWrite(CW, '* * Channel '+TmpStr+' is full (+l), cannot join');
        End;
  472 : WlnWrite(CW, '*** "'+TmpStr+'" is an unknown mode char to me');
  473 : Begin
          WlnWrite(CW, '* * Cannot join '+TmpStr+' because it is for Invited Only (+i)');
        End;
  474 : Begin
          WlnWrite(CW, '* * Cannot join '+TmpStr+' do not have correct channel Key (+k)');
        End;
  481 : WlnWrite(CW, '*** Permission Denied- You''re not an IRC operator');
  482 : WlnWrite(CW, '*** You''re not a channel operator on '+TmpStr);
  483 : WlnWrite(CW, '*** You can''t kill a server!');
  491 : WlnWrite(CW, '* * No O-lines for your host');
  501,502 : WlnWrite(CW, '* * '+PARSERREST(CIN_Line,3));

{$IFDEF IRCX}
{The Following is IRCX Messages:}
(*************
  800 :
  801 :
  802 :
  803 :
  804 :
  805 :
  806 :
  807 :
  808 :
  809 :
  810 :
*************)
  900..919 : WlnWrite(CW, '*** IRCX Error: '+PARSERREST(CIN_Line,3));
  999 : WlnWrite(CW, '*** IRCX Internal Error: '+PARSERREST(CIN_Line,3));
{$ENDIF}
    Else
      WlnWrite(CW,'['+CIN_Line+']');
   End;
(*******
 Str(Msg.Res, TmpStr);
 WlnWrite(CW,'('+TmpStr+')');
*********)
If Msg.Res=0 then
   begin
{     WlnWrite(CW,'*'+CFirst+' '+CSecond+' '+CThird+'*'); }
   end;

End;



BEGIN
END.

